-- firewall-ruleCLI.lua
-- Neelima
-- TeamF1
-- 10/10/08
-- 
-- Modification History
-- 13Dec13,AKr  Fixed SPR 41157
-- 04Jul12,sig  Fixed SPR 33185
-- 27Jun12,sig  Fixed SPR 32957
-- 11may12,nik  fixed SPR 31422
-- 28mar12,akr  splitted show firewall rules as per GUI 
-- 15mar12,akr  fixed 30767
-- 15mar12,sig  additional fixed spr 30383
-- 07Mar12,sig  fixed spr 30383
-- 05Mar12,akr added bandwidth profile in show firewall command
-- 07Feb12,akr fixed 29746
-- 23jan12,akr fixed 29380
-- 19jan12,akr fixed 29289
-- 29dec11,akr  fixed show ipv4 firewallrule inbound case
-- 27nov11,akr  fix 28092 and 28099 
-- 3nov11,akr  fix for validating serviceName dynamically in firewall cli
-- 27feb10,rac  added functons to support ALGs and modified all other functions to support the new changes 
-- 17feb09,ss   added validation checks to fix spr#10808 
-- 31jan09,ss   modified accessControlRuleInfoGet() to fix spr#10544 
-- 10dec08,ss   did modifications for rmi 
-- 07oct08,nlm, written
--
-- Description
-- CLISH Firewall rule LUA routines
--
-- Required Libraries

require "teamf1lualib/fwView"
require "teamf1lualib/fwRules"
require "teamf1lualib/algs"
require "teamf1lualib/db"
require "teamf1lualib/utilitiesCLI"
require "teamf1lualib/ifDev"
require "teamf1lualib/sip"

--functin returning lan-group name
function lanGroupNameGet(index) --index is string
	local name=''
    	local LanGroupTable = db.getTable("LanGroup")
	if(index ~= nil and LanGroupTable ~= nil)then
        	if(index == "3") then
        		name = LanGroupTable[1]["LanGroup.GroupName"] or '' 
        	elseif(index == "4") then
        	        name = LanGroupTable[2]["LanGroup.GroupName"] or ''
        	elseif(index == "5") then
        	        name = LanGroupTable[3]["LanGroup.GroupName"] or ''
        	elseif(index == "6") then
        	        name = LanGroupTable[4]["LanGroup.GroupName"] or ''
        	elseif(index == "7") then
        	        name = LanGroupTable[5]["LanGroup.GroupName"] or ''
        	elseif(index == "8") then
        	        name = LanGroupTable[6]["LanGroup.GroupName"] or ''
        	elseif(index == "9") then
        	        name = LanGroupTable[7]["LanGroup.GroupName"] or ''
        	elseif(index == "10") then
        	        name = LanGroupTable[8]["LanGroup.GroupName"] or ''
            else
                    name = db.getAttribute ("ipGroup","ipGroupId",index,"ipGroupName") or ''
	        end
	end
	return name or ''
end
--functin to get the name of qos priority
function qosPriorityGet(Index)
	local QOS_Priority =""
	if(Index ~= nil )then
		if(Index == "0")then
 			QOS_Priority ="Normal-Service"
		elseif(Index == "1")then
			QOS_Priority = "Minimize-Cost"
		elseif(Index == "2")then
			QOS_Priority = "Maximize-Reliability"
		elseif(Index == "4")then
			QOS_Priority = "Maximize-Throughput"
		elseif(Index == "8")then
			QOS_Priority="Minimize-Delay"
 		else
		 	QOS_Priority = "Normal-Service"
		end
	elseif(Index == nil or Index == "")then
	 	QOS_Priority = "Normal-Service"
	end
	return QOS_Priority or ''
end

--function to return action
function filterGet(ActionCode)
	local action = ''
	if(ActionCode ~= nil)then
		if ( ActionCode == "ACCEPT") then
                    action = "ALLOW Always"
                elseif (ActionCode == "DROP") then
                    action = "BLOCK Always"
                elseif (ActionCode == "DROP_BY_SCHEDULE") then
                    action = "BLOCK by schedule,otherwise allow"
                elseif (ActionCode == "ACCEPT_BY_SCHEDULE") then
                    action = "ALLOW by schedule,otherwise block"
                end
	end
	return action or ''
end

--lan-wan rules show
function accessControlLWRuleInfoGet(args)
    local defRow = db.getRow("FirewallRules", "RuleType", "DEFAULT_POLICY")
    local LanGroupTable = db.getTable("LanGroup")
    local resultTab = {} -- table to store firewall rules
    if (defRow["FirewallRules.Action"] == "ACCEPT") then 
        print ("Default Outbound Policy for IPv4 : Allow Always")
    elseif(defRow["FirewallRules.Action"] == "DROP") then
        print ("Default Outbound Policy for IPv4 : Block Always")
    end
    local lanWanOutBoundTable = db.getRows("FirewallRules","RuleType","SECURE_INSECURE")
    local resultTab = {}
    local n= 0
    if(#lanWanOutBoundTable ~= 0)then
	n=0
	for k,v in pairs(lanWanOutBoundTable) do
	    n = n + 1
	    local firewallRow = lanWanOutBoundTable[n]
	    if(firewallRow ~= nil)then
            local status= ''
            local logLevel = 'Never'
            local lanUserOB = ''
            local lanUserIB = ''
            local wanUserOB = ''
            local wanUserIB = ''
            local sendToLanServer = ''
            local destination = ''
		    if(firewallRow["FirewallRules.Status"] == "0") then
			status =  "Disabled"
		    elseif(firewallRow["FirewallRules.Status"] == "1") then
    			status =  "Enabled"
		    end
	            resTab.insertField (resultTab, "ROWID", firewallRow["FirewallRules._ROWID_"] or "")
	            resTab.insertField (resultTab, "Status",  status or "")
	            resTab.insertField (resultTab, "Service Name", firewallRow["FirewallRules.ServiceName"]  or "")
	            resTab.insertField (resultTab, "Filter", filterGet(firewallRow["FirewallRules.Action"]) or "")
		    if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    	lanUserOB = "Any"
	            elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    	lanUserOB = firewallRow["FirewallRules.SourceAddressStart"]
                    elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    	lanUserOB = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
                    else
		       lanUserOB = lanGroupNameGet(firewallRow["FirewallRules.SourceAddressType"])
		    end
                    if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    	wanUserOB = "Any"
                    elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    	wanUserOB = firewallRow["FirewallRules.DestinationAddressStart"]
	            elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
	                wanUserOB = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
                else
                    wanUserOB = db.getAttribute ("ipGroup","ipGroupId",firewallRow["FirewallRules.DestinationAddressType"],"ipGroupName") or ''
		    end
	            resTab.insertField (resultTab, "LAN User", lanUserOB or "")
	            resTab.insertField (resultTab, "WAN User", wanUserOB or "")
                if (firewallRow["FirewallRules.QosProfileName"] == "0") then
                    firewallRow["FirewallRules.QosProfileName"] = "None"
                end
	            resTab.insertField (resultTab, "QoS Profile", firewallRow["FirewallRules.QosProfileName"] or "")
	            resTab.insertField (resultTab, "Bandwidth Profile", firewallRow["FirewallRules.BandwidthProfileName"] or "NONE")
   	            if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    	logLevel = "Never" 
                    elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    	logLevel = "Always"
                    end 
	            resTab.insertField (resultTab, "Log", logLevel or "")
	    end
	end
    end

    printLabel("LAN WAN Outbound Rules.")   
    resTab.print (resultTab, 0)

    resultTab = {} 
    local lanWanInBoundTable = db.getRows("FirewallRules","RuleType","INSECURE_SECURE")
        if(#lanWanInBoundTable ~= 0)then
	n=0
	for k,v in pairs(lanWanInBoundTable) do
	    n = n + 1
	    local firewallRow = lanWanInBoundTable[n]
	    if(firewallRow ~= nil)then
            local status= ''
            local logLevel = 'Never'
            local lanUserOB = ''
            local lanUserIB = ''
            local wanUserOB = ''
            local wanUserIB = ''
            local sendToLanServer = ''
            local destination = ''
		    if(firewallRow["FirewallRules.Status"] == "0") then
			status =  "Disabled"
		    elseif(firewallRow["FirewallRules.Status"] == "1") then
    			status =  "Enabled"
		    end
	            resTab.insertField (resultTab, "ROWID", firewallRow["FirewallRules._ROWID_"] or "")
	            resTab.insertField (resultTab, "Status",  status or "")
	            resTab.insertField (resultTab, "Service Name", firewallRow["FirewallRules.ServiceName"]  or "")
	            resTab.insertField (resultTab, "Filter", filterGet(firewallRow["FirewallRules.Action"]) or "")
		    if(firewallRow["FirewallRules.DNATAddressType"] == "1")then
			sendToLanServer = firewallRow["FirewallRules.DNATAddress"] or ''
		    elseif(firewallRow["FirewallRules.DNATAddressType"] == "2")then
			sendToLanServer = firewallRow["FirewallRules.DNATAddress"] .. "-" .. firewallRow["FirewallRules.DNATAddressEnd"]
		    end
	            resTab.insertField (resultTab, "LAN Server IP Address / NAT IP", sendToLanServer or "")
		    if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    	wanUserIB = "Any"
	            elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    	wanUserIB = firewallRow["FirewallRules.SourceAddressStart"]
                    elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    	wanUserIB = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
                    else
                        wanUserIB = db.getAttribute ("ipGroup","ipGroupId",firewallRow["FirewallRules.SourceAddressType"],"ipGroupName") or ''
		    end
                    if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    	lanUserIB = "Any"
                    elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    	lanUserIB = firewallRow["FirewallRules.DestinationAddressStart"]
	            elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
	                lanUserIB = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
                    else
		        lanUserIB = lanGroupNameGet(firewallRow["FirewallRules.DestinationAddressType"])
		    end
	            resTab.insertField (resultTab, "LAN User", lanUserIB or "")
	            resTab.insertField (resultTab, "WAN User", wanUserIB or "")
			    destination = firewallRow["FirewallRules.DestinationPublicInterface"]
		    if(firewallRow["FirewallRules.DestinationPublicInterface"] == "OTHER")then
			destination = firewallRow["FirewallRules.DestinationPublicAddress"] or ''
		    elseif(firewallRow["FirewallRules.DestinationPublicInterface"] == "RANGE")then
			destination = firewallRow["FirewallRules.DestinationPublicAddress"].."-".. firewallRow["FirewallRules.DestinationPublicAddressEnd"]
		    end
	            resTab.insertField (resultTab, "Destination", destination or "")
                if (firewallRow["FirewallRules.QosProfileName"] == "0") then
                    firewallRow["FirewallRules.QosProfileName"] = "None"
                end
	            resTab.insertField (resultTab, "QoS Profile", firewallRow["FirewallRules.QosProfileName"] or "")
	            resTab.insertField (resultTab, "Bandwidth Profile", firewallRow["FirewallRules.BandwidthProfileName"] or "NONE")
   	            if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    	logLevel = "Never" 
                    elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    	logLevel = "Always"
                    end 
	            resTab.insertField (resultTab, "Log", logLevel or "")
	    end
	end
    end
    printLabel("LAN WAN Inbound Rules.")
    resTab.print (resultTab, 0)
end

--lan-dmz rules show
function accessControlLDRuleInfoGet(args)
    local defRow = db.getRow("FirewallRules", "RuleType", "DEFAULT_POLICY")
    local LanGroupTable = db.getTable("LanGroup")
    local resultTab = {} -- table to store firewall rules
    if (defRow["FirewallRules.Action"] == "ACCEPT") then 
        print ("Default Outbound Policy for IPv4 : Allow Always")
    elseif(defRow["FirewallRules.Action"] == "DROP") then
        print ("Default Outbound Policy for IPv4 : Block Always")
    end
    local lanDmzOutBoundTable = db.getRows("FirewallRules","RuleType","SECURE_PUBLIC")
    local resultTab = {}
    local n= 0
    if(#lanDmzOutBoundTable ~= 0)then
	n=0
	for k,v in pairs(lanDmzOutBoundTable) do
	    n = n + 1
	    local firewallRow = lanDmzOutBoundTable[n]
	    if(firewallRow ~= nil)then
            local status= ''
            local logLevel = 'Never'
            local lanUserOB = ''
            local lanUserIB = ''
            local dmzUserOB = ''
            local dmzUserIB = ''
		    if(firewallRow["FirewallRules.Status"] == "0") then
			status =  "Disabled"
		    elseif(firewallRow["FirewallRules.Status"] == "1") then
    			status =  "Enabled"
		    end
		    resTab.insertField (resultTab, "ROWID", firewallRow["FirewallRules._ROWID_"] or "")
	            resTab.insertField (resultTab, "Status",  status or "")
	            resTab.insertField (resultTab, "Service Name", firewallRow["FirewallRules.ServiceName"]  or "")
	            resTab.insertField (resultTab, "Filter", filterGet(firewallRow["FirewallRules.Action"]) or "")
		    if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    	lanUserOB = "Any"
	            elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    	lanUserOB = firewallRow["FirewallRules.SourceAddressStart"]
                    elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    	lanUserOB = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
                    else
		       lanUserOB = lanGroupNameGet(firewallRow["FirewallRules.SourceAddressType"])
		    end
                    if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    	dmzUserOB = "Any"
                    elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    	dmzUserOB = firewallRow["FirewallRules.DestinationAddressStart"]
	            elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
	                dmzUserOB = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
		    end
	            resTab.insertField (resultTab, "LAN User", lanUserOB or "")
	            resTab.insertField (resultTab, "DMZ User", dmzUserOB or "")
   	            if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    	logLevel = "Never" 
                    elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    	logLevel = "Always"
                    end 
	            resTab.insertField (resultTab, "Log", logLevel or "")
	    end
	end
    end
    printLabel("LAN DMZ Outbound Rules.")
    resTab.print (resultTab,0)

    resultTab = {}
    local lanDmzInBoundTable = db.getRows("FirewallRules","RuleType","PUBLIC_SECURE")
    if(#lanDmzInBoundTable ~= 0)then
	n=0
	for k,v in pairs(lanDmzInBoundTable) do
	    n = n + 1
	    local firewallRow = lanDmzInBoundTable[n]
	    if(firewallRow ~= nil)then
            local status= ''
            local logLevel = 'Never'
            local lanUserOB = ''
            local lanUserIB = ''
            local dmzUserOB = ''
            local dmzUserIB = ''
		    if(firewallRow["FirewallRules.Status"] == "0") then
			status =  "Disabled"
		    elseif(firewallRow["FirewallRules.Status"] == "1") then
    			status =  "Enabled"
		    end
		    resTab.insertField (resultTab, "ROWID", firewallRow["FirewallRules._ROWID_"] or "")
	            resTab.insertField (resultTab, "Status",  status or "")
	            resTab.insertField (resultTab, "Service Name", firewallRow["FirewallRules.ServiceName"]  or "")
	            resTab.insertField (resultTab, "Filter", filterGet(firewallRow["FirewallRules.Action"]) or "")
		    if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    	dmzUserIB = "Any"
	            elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    	dmzUserIB = firewallRow["FirewallRules.SourceAddressStart"]
                    elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    	dmzUserIB = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
		    end
                    if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    	lanUserIB = "Any"
                    elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    	lanUserIB = firewallRow["FirewallRules.DestinationAddressStart"]
	            elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
	                lanUserIB = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
                    else
		       lanUserIB= lanGroupNameGet(firewallRow["FirewallRules.DestinationAddressType"])
		    end
	            resTab.insertField (resultTab, "DMZ User", dmzUserIB or "")
	            resTab.insertField (resultTab, "LAN User", lanUserIB or "")
   	            if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    	logLevel = "Never" 
                    elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    	logLevel = "Always"
                    end 
	            resTab.insertField (resultTab, "Log", logLevel or "")
	    end
	end
    end
    printLabel("LAN DMZ Inbound Rules.")
    resTab.print (resultTab,0)

end
--dmz-wan rules show
function accessControlDWRuleInfoGet(args)
    local defRow = db.getRow("FirewallRules", "RuleType", "DEFAULT_POLICY")
    local resultTab = {} -- table to store firewall rules
    if (defRow["FirewallRules.Action"] == "ACCEPT") then 
        print ("Default Outbound Policy for IPv4 : Allow Always")
    elseif(defRow["FirewallRules.Action"] == "DROP") then
        print ("Default Outbound Policy for IPv4 : Block Always")
    end
    local dmzWanOutBoundTable = db.getRows("FirewallRules","RuleType","PUBLIC_INSECURE")
    local resultTab = {}
    local n= 0
    if(#dmzWanOutBoundTable ~= 0)then
	n=0
	for k,v in pairs(dmzWanOutBoundTable) do
	    n = n + 1
	    local firewallRow = dmzWanOutBoundTable[n]
	    if(firewallRow ~= nil)then
            local status= ''
            local logLevel = 'Never'
            local dmzUserOB = ''
            local dmzUserIB = ''
            local wanUserOB = ''
            local wanUserIB = ''
            local destination = ''
		    if(firewallRow["FirewallRules.Status"] == "0") then
			status =  "Disabled"
		    elseif(firewallRow["FirewallRules.Status"] == "1") then
    			status =  "Enabled"
		    end
	            resTab.insertField (resultTab, "ROWID", firewallRow["FirewallRules._ROWID_"] or "")
	            resTab.insertField (resultTab, "Status",  status or "")
	            resTab.insertField (resultTab, "Service Name", firewallRow["FirewallRules.ServiceName"]  or "")
	            resTab.insertField (resultTab, "Filter", filterGet(firewallRow["FirewallRules.Action"]) or "")
		    if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    	dmzUserOB = "Any"
	            elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    	dmzUserOB = firewallRow["FirewallRules.SourceAddressStart"]
                    elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    	dmzUserOB = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
		    end
                    if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    	wanUserOB = "Any"
                    elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    	wanUserOB = firewallRow["FirewallRules.DestinationAddressStart"]
	            elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
	                wanUserOB = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
                else
                    wanUserOB = db.getAttribute ("ipGroup","ipGroupId",firewallRow["FirewallRules.DestinationAddressType"],"ipGroupName") or ''
		    end
	            resTab.insertField (resultTab, "DMZ User", dmzUserOB or "")
	            resTab.insertField (resultTab, "WAN User", wanUserOB or "")
                if (firewallRow["FirewallRules.QosProfileName"] == "0") then
                    firewallRow["FirewallRules.QosProfileName"] = "None"
                end
	            resTab.insertField (resultTab, "QoS Profile", firewallRow["FirewallRules.QosProfileName"] or "")
   	            if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    	logLevel = "Never" 
                    elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    	logLevel = "Always"
                    end 
	            resTab.insertField (resultTab, "Log", logLevel or "")
	    end
	end
    end

    printLabel("DMZ WAN Outbound Rules.")
    resTab.print (resultTab, 0)

    resultTab = {} 
    local dmzWanInBoundTable = db.getRows("FirewallRules","RuleType","INSECURE_PUBLIC")
        if(#dmzWanInBoundTable ~= 0)then
	n=0
	for k,v in pairs(dmzWanInBoundTable) do
	    n = n + 1
	    local firewallRow = dmzWanInBoundTable[n]
	    if(firewallRow ~= nil)then
            local status= ''
            local logLevel = 'Never'
            local dmzUserOB = ''
            local dmzUserIB = ''
            local wanUserOB = ''
            local wanUserIB = ''
            local destination = ''
		    if(firewallRow["FirewallRules.Status"] == "0") then
			status =  "Disabled"
		    elseif(firewallRow["FirewallRules.Status"] == "1") then
    			status =  "Enabled"
		    end
	            resTab.insertField (resultTab, "ROWID", firewallRow["FirewallRules._ROWID_"] or "")
	            resTab.insertField (resultTab, "Status",  status or "")
	            resTab.insertField (resultTab, "Service Name", firewallRow["FirewallRules.ServiceName"]  or "")
	            resTab.insertField (resultTab, "Filter", filterGet(firewallRow["FirewallRules.Action"]) or "")
	            resTab.insertField (resultTab, "DMZ Server IP Address / NAT IP", firewallRow["FirewallRules.DNATAddress"] or "")
		    if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    	wanUserIB = "Any"
	            elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    	wanUserIB = firewallRow["FirewallRules.SourceAddressStart"]
                    elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    	wanUserIB = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
                    else
                        wanUserIB = db.getAttribute ("ipGroup","ipGroupId",firewallRow["FirewallRules.SourceAddressType"],"ipGroupName") or ''
		    end
                    if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    	dmzUserIB = "Any"
                    elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    	dmzUserIB = firewallRow["FirewallRules.DestinationAddressStart"]
	            elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
	                dmzUserIB = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
		    end
	            resTab.insertField (resultTab, "DMZ User", dmzUserIB or "")
	            resTab.insertField (resultTab, "WAN User", wanUserIB or "")
			destination = firewallRow["FirewallRules.DestinationPublicInterface"]
		    if(firewallRow["FirewallRules.DestinationPublicInterface"] == "OTHER")then
			destination = firewallRow["FirewallRules.DestinationPublicAddress"] or ''
		    end
	            resTab.insertField (resultTab, "Destination", destination or "")
                if (firewallRow["FirewallRules.QosProfileName"] == "0") then
                    firewallRow["FirewallRules.QosProfileName"] = "None"
                end
	            resTab.insertField (resultTab, "QoS Profile", firewallRow["FirewallRules.QosProfileName"] or "")
   	            if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    	logLevel = "Never" 
                    elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    	logLevel = "Always"
                    end 
	            resTab.insertField (resultTab, "Log", logLevel or "")
	    end
	end
    end
    printLabel("DMZ WAN Inbound Rules.")
    resTab.print (resultTab, 0)

end
function accessControlRuleInfoGet (args)
    local firewallTable = db.getTable ("FirewallRules")
    local resultTab = {} -- table to store firewall rules
    local firewallRow = nil
    local rowId = "0"
    local status = nil
    local fromzone = nil
    local tozone = nil
    local destusrs = nil
    local srcusrs = nil
    local action = nil
    local status = nil

    printLabel ("Default Outbound Policy")
    defRow = db.getRow("FirewallRules", "RuleType", "DEFAULT_POLICY")
    LanGroupTable = db.getTable("LanGroup")
    if (defRow["FirewallRules.Action"] == "ACCEPT") then 
        print ("For IPv4 : Allow Always\n")
    elseif(defRow["FirewallRules.Action"] == "DROP") then
        print ("For IPv4 : Block Always")
    end
    printLabel ("List of Available IPv4 Firewall Rules")    
    for col, val in pairs(firewallTable) do
        rowId = rowId+1
        local firewallRow = firewallTable[rowId]
	if (rowId ~= nil) then
            if (firewallRow["FirewallRules._metadata"] ~= "edit=0" and firewallRow["FirewallRules.RuleType"] ~= "DEFAULT_POLICY") then
                if(firewallRow["FirewallRules.Status"] == "0") then
                    status =  "Disabled"
                elseif(firewallRow["FirewallRules.Status"] == "1") then
                    status =  "Enabled"
                end
                if(firewallRow["FirewallRules.FromZoneType"] == "SECURE") then
                    fromzone = "LAN"
                elseif (firewallRow["FirewallRules.FromZoneType"] == "INSECURE")then
	    	        fromzone = "WAN"
             	else
		            fromzone = "DMZ"
                end
            
        	  	if(firewallRow["FirewallRules.ToZoneType"] == "SECURE") then
                    tozone = "LAN"
	            elseif (firewallRow["FirewallRules.ToZoneType"] == "INSECURE")then
		            tozone = "WAN"
        		else 
	        	    tozone = "DMZ"
                end
	
                if (firewallRow["FirewallRules.Action"] == "ACCEPT") then
                    action = "ALLOW Always"
                elseif (firewallRow["FirewallRules.Action"] == "DROP") then
                    action = "BLOCK Always"
                elseif (firewallRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE") then
                    action = "BLOCK by schedule, otherwise allow"
                elseif (firewallRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE") then
                    action = "ALLOW by schedule,otherwise block"
                end
                if(firewallRow["FirewallRules.SourceAddressType"] == "0") then
                    srcusrs = "Any"
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "1") then
                    srcusrs = firewallRow["FirewallRules.SourceAddressStart"]
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "2") then
                    srcusrs = firewallRow["FirewallRules.SourceAddressStart"] .. " - " .. firewallRow["FirewallRules.SourceAddressEnd"]
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "3") then
                    srcusrs = LanGroupTable[1]["LanGroup.GroupName"] or '' 
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "4") then
                    srcusrs = LanGroupTable[2]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "5") then
                    srcusrs = LanGroupTable[3]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "6") then
                    srcusrs = LanGroupTable[4]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "7") then
                    srcusrs = LanGroupTable[5]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "8") then
                    srcusrs = LanGroupTable[6]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "9") then
                    srcusrs = LanGroupTable[7]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "10") then
                    srcusrs = LanGroupTable[8]["LanGroup.GroupName"] or ''
                end
                if(firewallRow["FirewallRules.DestinationAddressType"] == "0") then
                    destusrs = "Any"
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "1") then
                    destusrs = firewallRow["FirewallRules.DestinationAddressStart"]
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "2") then
                    destusrs = firewallRow["FirewallRules.DestinationAddressStart"] .. " - " .. firewallRow["FirewallRules.DestinationAddressEnd"]
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "3") then
                    destusrs = LanGroupTable[1]["LanGroup.GroupName"] or '' 
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "4") then
                    destusrs = LanGroupTable[2]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "5") then
                    destusrs = LanGroupTable[3]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "6") then
                    destusrs = LanGroupTable[4]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.SourceAddressType"] == "7") then
                    destusrs = LanGroupTable[5]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "8") then
                    destusrs = LanGroupTable[6]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "9") then
                    destusrs = LanGroupTable[7]["LanGroup.GroupName"] or ''
                elseif(firewallRow["FirewallRules.DestinationAddressType"] == "10") then
                    destusrs = LanGroupTable[8]["LanGroup.GroupName"] or ''
                end
		local localServer = ""
		local internetDestination = ""
                if(firewallRow["FirewallRules.DNATAddress"] ~= nil and firewallRow["FirewallRules.DNATAddressEnd"] ~= nil) then
                    localServer = firewallRow["FirewallRules.DNATAddress"] .. "-" ..  firewallRow["FirewallRules.DNATAddressEnd"]
                elseif(firewallRow["FirewallRules.DNATAddress"] ~= nil and firewallRow["FirewallRules.DNATAddressEnd"] == nil) then
                    localServer = firewallRow["FirewallRules.DNATAddress"]
                end
                if(firewallRow["FirewallRules.DestinationPublicAddress"] ~= nil and firewallRow["FirewallRules.DestinationPublicAddressEnd"] ~= nil) then
                    internetDestination = firewallRow["FirewallRules.DestinationPublicAddress"] .. "-" ..  firewallRow["FirewallRules.DestinationPublicAddressEnd"]
                elseif(firewallRow["FirewallRules.DestinationPublicAddress"] ~= nil and firewallRow["FirewallRules.DestinationPublicAddressEnd"] == nil) then
                    internetDestination = firewallRow["FirewallRules.DestinationPublicAddress"]
                end
                if (firewallRow["FirewallRules.LogLevel"] == "1") then
                    logLevel = "Never" 
                elseif (firewallRow["FirewallRules.LogLevel"] == "2") then
                    logLevel = "Always"
                end 
		if ( firewallRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE" or firewallRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE") then
		    if (firewallRow["FirewallRules.ScheduleName"] ~= nil or firewallRow["FirewallRules.ScheduleName"] ~= "") then 
			    resTab.insertField(resultTab,"Schedule",firewallRow["FirewallRules.ScheduleName"] or '')
		    end
		 else 
			    resTab.insertField(resultTab,"Schedule","")
		 end
                resTab.insertField (resultTab, "ROW ID", firewallRow["FirewallRules._ROWID_"] or "")
                resTab.insertField (resultTab, "Status",  status or "")
                resTab.insertField (resultTab, "From Zone",fromzone)
                resTab.insertField (resultTab, "To Zone",tozone)
                resTab.insertField (resultTab, "Service", firewallRow["FirewallRules.ServiceName"] or "")
                resTab.insertField (resultTab, "Action", action or "")
                resTab.insertField (resultTab, "Source Hosts", srcusrs or "")
                resTab.insertField (resultTab, "Destination Hosts", destusrs or "")
                resTab.insertField (resultTab, "Local Server",localServer or "")
                resTab.insertField (resultTab, "Internet Dest", internetDestination or "")
                resTab.insertField (resultTab, "Log",  logLevel or "")
		if(firewallRow["FirewallRules.RuleType"] == "SECURE_INSECURE" or firewallRow["FirewallRules.RuleType"] == "PUBLIC_INSECURE")then
			if(firewallRow["FirewallRules.TypeOfService"] == "0")then
				resTab.insertField (resultTab,"QOS Priority","Normal-Service")
			elseif(firewallRow["FirewallRules.TypeOfService"] == "1")then
				resTab.insertField (resultTab,"QOS Priority","Minimize-Cost")
			elseif(firewallRow["FirewallRules.TypeOfService"] == "2")then
				resTab.insertField (resultTab,"QOS Priority","Maximize-Reliability")
			elseif(firewallRow["FirewallRules.TypeOfService"] == "4")then
				resTab.insertField (resultTab,"QOS Priority","Maximize-Throughput")
			elseif(firewallRow["FirewallRules.TypeOfService"] == "8")then
				resTab.insertField (resultTab,"QOS Priority","Minimize-Delay")
			else
				resTab.insertField (resultTab,"QOS Priority","Normal-Service")
			end
		else
			resTab.insertField (resultTab, "QOS Priority","Not Applicable")
		end
		if(firewallRow["FirewallRules.BandwidthProfileName"]== "" or firewallRow["FirewallRules.BandwidthProfileName"] == nil )then
	                resTab.insertField (resultTab, "Bandwidth Profile", "NONE")
		elseif(firewallRow["FirewallRules.BandwidthProfileName"] ~= nil )then
                	resTab.insertField (resultTab, "Bandwidth Profile", firewallRow["FirewallRules.BandwidthProfileName"] or "")
		end
		if (firewallRow["FirewallRules.SNATAddressType"] ~= nil and firewallRow["FirewallRules.SNATAddressType"] ~= "" ) then
			if (firewallRow["FirewallRules.SNATAddressType"] == "1") then
				resTab.insertField ( resultTab, "SNAT Address ",firewallRow["FirewallRules.SNATAddress"] or "")
			elseif(firewallRow["FirewallRules.SNATAddressType"] == "7") then
				resTab.insertField ( resultTab, "SNAT Address ","WAN Interface")
			end
		else
				resTab.insertField ( resultTab, "SNAT Address ","NOT Applicable")
		end
            end -- if _metadata
        end -- if rowid nil
    end -- for 
    resTab.print (resultTab, 0)
end

-- This function enables/disables/deletes one rule at a time.
function accessControlRuleModify(args)
    local errorFlag = "Error"
    local statusCode =""
    local statusMessage =""
    DBTable= "FirewallRules"     
    local rowIds={}
    rowIds["rowId"] = args[1]
    local operation = args[2]
    local defRow= db.getAttribute("FirewallRules","RuleType","DEFAULT_POLICY","_ROWID_")
    local existRow= db.getRow("FirewallRules","_ROWID_",args[1])
    if(defRow >= args[1] and operation == "delete") then
        printCLIError("Firewall Rule cannot be deleted")
        return errorFlag, statusMessage    
    elseif(existRow == nil) then
        printCLIError("Firewall Rule not exist")
        return errorFlag, statusMessage    
    else
        errorFlag, statusMessage = fwView.modifyRules(rowIds, operation)
    end
    if (errorFlag == "OK") then
        db.save()
    end
    accessControlRuleInfoGet()
    return errorFlag, statusMessage
end    

-- this routine reads in a current access control rule configuration into a 
-- configuration object. Or wii just initialize the defaults in case a new
-- rule is getting added.
function accessControlRuleCfgInit(args)
    local rowId = args[1]
    local configRow={}
    if (rowId == nil) then
        -- setting default values
        --configRow = db.getDefaults(true, "FirewallRules")
        configRow["FirewallRules.Status"]="1"
    else
        configRow= db.getRow("FirewallRules","_ROWID_",rowId)
        if (configRow == nil) then
           print("Row does not exist")          
           return -1
        end
    end
    return -1,configRow
end

function DeleteStaleInput()
	__CLISH_CUR_CONFIG_ROW = {} -- current config info is now discarded
 	__CLISH_EDIT_CONFIG_ROW = {} -- current edit config info is discarded
	return true
end

-- The routine saves the modified/ newly added access control rule
function accessControlRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    if (configRow["FirewallRules._ROWID_"] == nil) then
	configRow["FirewallRules.DNATPortEnable"]="0"
	configRow["FirewallRules.RuleType"]=nil
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()    
--[[	local cacheResetProgram = db.getAttribute("environment", "name", "HW_CACHE_RESET", "value")
	util.appendDebugOut("Exec: " .. os.execute(cacheResetProgram));]]
    end
    return errorFlag, statusMessage
end    

function accessControlRuleCfgInputVal (configRow)

	if (configRow["FirewallRules.FromZoneType"] == nil or configRow["FirewallRules.FromZoneType"] == "")then
		printCLIError("Invalid from_zone")
		return false
	end	
	if (configRow["FirewallRules.ToZoneType"] == nil or configRow["FirewallRules.ToZoneType"] == "")then
		printCLIError("Invalid to_zone")
		return false
	end 
	if (configRow["FirewallRules.ToZoneType"] == configRow["FirewallRules.FromZoneType"])then
		printCLIError("from_zone and to_zone are expected to be different values")
		return false
	end
	if (configRow["FirewallRules.ServiceName"] == nil or configRow["FirewallRules.ServiceName"] == "")then
		printCLIError("Please Enter service_name.")
		return false
	elseif (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
	if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end
	if (configRow["FirewallRules.Action"] == nil or configRow["FirewallRules.Action"] == "")then
		printCLIError("Invalid action value")
		return false
	end
	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end	
	end
--	if (configRow["FirewallRules.FromZoneType"] == "SECURE" and configRow["FirewallRules.ToZoneType"] == "INSECURE" and (configRow["FirewallRules.TypeOfService"] == "" or configRow["FirewallRules.TypeOfService"] == nil))then
--		printCLIError("Invalid qos_priority")
--		return false
--	end

--[[ Validation in case of Multiple WAN
	if (configRow["FirewallRules.SNATAddressType"] == "7" and (configRow["FirewallRules.SNATInterface"] == nil or configRow["FirewallRules.SNATInterface"] =="")) then
		printCLIError("Invalid  wan_interface")
		return false
	end
]]
	if (configRow["FirewallRules.LogLevel"] == nil or configRow["FirewallRules.LogLevel"] == "")then
		printCLIError("Invalid log value")
		return false
	end

--[[
	if ((configRow["FirewallRules.SourceAddressType"] == nil or configRow["FirewallRules.SourceAddressType"] == "") and ( configRow["FirewallRules.SourceAddressTypeG"] == nil ))then
		printCLIError("Invalid source_address_type")
		return false
	end
]]
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" ) then
			printCLIError("Enter source_address_start.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2' and (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" )) then
			printCLIError("Enter source_address_end.")
			return false
		end
	end
--[[	
	if((configRow["FirewallRules.DestinationAddressType"] == nil or configRow["FirewallRules.SourceAddressType"] == "")and (configRow["FirewallRules.DestinationAddressTypeG"] == nil ))then
		printCLIError("Invalid destination_address_type")
		return false
	end
]]
	if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
		if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == "" ) then
			printCLIError("Enter destination_address_start.")
			return false
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "2")then
		if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
			printCLIError("Invalid destination_address_end. ")
			return false
		end
	end


-- source address validation 
	if ( configRow["FirewallRules.FromZoneType"] == "INSECURE" and configRow["FirewallRules.ToZoneType"] == "SECURE") then
		--LAN WAN INBOUND
	    if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT MODE
		if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil and configRow["FirewallRules.SourceAddressType"] == nil) then
			printCLIError("source_address_type group_wise not applicable")
			return false
		end
		if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil and configRow["FirewallRules.DestinationAddressType"] == nil) then
			printCLIError("destination_address_type group_wise not applicable")
			return false
		end
		if ( configRow["FirewallRules.DNATAddressType"] == nil or configRow["FirewallRules.DNATAddressType"] == "") then
			printCLIError("Please Select option for  send_to_server.")
			return false
		elseif ( configRow["FirewallRules.DNATAddressType"] == "1" or configRow["FirewallRules.DNATAddressType"] == "2") then
			if ( configRow["FirewallRules.DNATAddress"] == nil or  configRow["FirewallRules.DNATAddress"] == "" ) then
				printCLIError("Please Enter internal_ip_address_start.")
				return false
			end
			if ( configRow["FirewallRules.DNATAddressType"] == "2" and ( configRow["FirewallRules.DNATAddressEnd"] == nil or configRow["FirewallRules.DNATAddressEnd"] == "" )) then 
				printCLIError("Please Enter internal_ip_address_end.")
				return false
			end
		end
		if (configRow["FirewallRules.DNATAddressType"] == "2" ) then
			if ( configRow["FirewallRules.DestinationPublicInterface"] ~= "RANGE") then
				printCLIError("If SendToLANServer is RANGE then dnat_ipaddress WILL BE RANGE. ")
				return false
			end
		end
		if (configRow["FirewallRules.DestinationPublicInterface"] == nil or configRow["FirewallRules.DestinationPublicInterface"] == "") then 
			printCLIError("Please Select option for dnat_ipaddress.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "OTHER" and ( configRow["FirewallRules.DestinationPublicAddress"] == nil or configRow["FirewallRules.DestinationPublicAddress"] == "")) then
			printCLIError("Enter the SendToLANServerIPStart.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "RANGE") then
			if( configRow["FirewallRules.DestinationPublicAddressEnd"] == nil or configRow["FirewallRules.DestinationPublicAddressEnd"] == "") then
				printCLIError("Enter the SendToLANServerIPEnd.")
				return false
			end
			if( configRow["FirewallRules.DestinationPublicAddress"] == nil or configRow["FirewallRules.DestinationPublicAddress"] == "") then
				printCLIError("Enter the SendToLANServerIPStart.")
				return false
			end
		end
	   else -- Classical Routing Mode
			if(configRow["FirewallRules.DestinationAddressType"] == nil and configRow["FirewallRules.DestinationAddressTypeG"] == nil )then printCLIError("Please Enter destination_address_type.") ; return false ; end
			if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil )then --DestinationAddressType is LAN Groups
				local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.DestinationAddressTypeG"],"rowid")
				if( LanGroupRowId == nil )then
					printCLIError("Lan Group Does not exist.")
					return false
				else
					configRow["FirewallRules.DestinationAddressType"] = tonumber(LanGroupRowId) +2
				end
			end
			if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil and configRow["FirewallRules.SourceAddressType"] == nil )then --SourceAddressType is LAN Groups
				printCLIError("source_address_type group_wise not applicable.")
				return false
			end
	   end
	   if ((configRow["FirewallRules.SourceAddressType"] == nil or configRow["FirewallRules.SourceAddressType"] == "") and ( configRow["FirewallRules.SourceAddressTypeG"] == nil ))then
		printCLIError("Invalid source_address_type")
		return false
	   end

	elseif (configRow["FirewallRules.FromZoneType"] == "INSECURE" and configRow["FirewallRules.ToZoneType"] == "PUBLIC" ) then
		--DMZ WAN INBOUND CASE 
		if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil and configRow["FirewallRules.SourceAddressType"] == nil) then
			printCLIError("source_address_type group_wise not applicable")
			return false
		end
		if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil and configRow["FirewallRules.DestinationAddressType"] == nil) then
			printCLIError("destination_address_type group_wise not applicable")
			return false
		end
		if(configRow["FirewallRules.SourceAddressType"] == nil or configRow["FirewallRules.SourceAddressType"] == "") then printCLIError("Please Enter source_address_type.") ; return false ; end
		if(configRow["FirewallRules.DestinationAddressType"] == nil or configRow["FirewallRules.DestinationAddressType"] == "") then printCLIError("Please Enter destination_address_type.") ; return false ; end
		if ( configRow["FirewallRules.DNATAddress"] == nil or configRow["FirewallRules.DNATAddress"] == "") then
			printCLIError("Please Enter internal_ip_address_start.")
			return false
		end
		if (configRow["FirewallRules.DNATPortEnable"] == nil or configRow["FirewallRules.DNATPortEnable"] == "") then 
			printCLIError("Please Select option for port_forwarding_enable.")
			return false
		elseif (configRow["FirewallRules.DNATPortEnable"] == "1" and (configRow["FirewallRules.DNATPort"] == nil or configRow["FirewallRules.DNATPort"] == "")) then
			printCLIError("Enter the dnat_port.")
			return false
		end
		if (configRow["FirewallRules.DestinationPublicInterface"] == nil or configRow["FirewallRules.DestinationPublicInterface"] == "") then 
			printCLIError("Please Select option for dnat_ipaddress.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "OTHER" and ( configRow["FirewallRules.DestinationPublicAddress"] == nil or configRow["FirewallRules.DestinationPublicAddress"] == "")) then
			printCLIError("Enter the SendToLANServerIPStart.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "RANGE" ) then
			printCLIError("IN Case of DMZ Inbound case dnat_ipaddress = RANGE is INVALID.")
			return false
		end

	end
-- destinaton address validation 
	--
	--			Validation for LAN_WAN_DMZ -IN/OUT BOUND
	--
	--	LAN WAN OUTBOUND CASE
	--
	if ( configRow["FirewallRules.FromZoneType"] == "SECURE" and configRow["FirewallRules.ToZoneType"] == "INSECURE") then	
		--TODO source_address_type has GROUPX option but cli is not taking this.. lateron it will be added
		if(configRow["FirewallRules.SourceAddressType"] == nil and configRow["FirewallRules.SourceAddressTypeG"] == nil)then printCLIError("Please Select source_address_type.") ; return false ; end
		if(configRow["FirewallRules.DestinationAddressType"] == nil and configRow["FirewallRules.DestinationAddressTypeG"] == nil)then printCLIError("Please Select destination_address_type.") ; return false ; end
--		if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT MODE
			if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil )then --SourceAddressType is LAN Groups
				local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.SourceAddressTypeG"],"rowid")
				if( LanGroupRowId == nil )then
					printCLIError("Lan Group Does not exist.")
					return false
				else
					configRow["FirewallRules.SourceAddressType"] = tonumber(LanGroupRowId) +2
				end
			end
			if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil and configRow["FirewallRules.DestinationAddressType"] == nil )then --SourceAddressType is LAN Groups
				printCLIError("destination_address_type group_wise not applicable.")
				return false
			end
--		end 
		if ( configRow["FirewallRules.Action"] ~= "DROP" ) then
			if ( configRow["FirewallRules.TypeOfService"] == nil or configRow["FirewallRules.TypeOfService"] == "") then
				printCLIError("Please Select qos_priority.")
				return false
			end
			if ( configRow["FirewallRules.BandwidthProfileName"] ~= nil) then
				if ( db.getAttribute("BandWidthProfile","ProfileName",configRow["FirewallRules.BandwidthProfileName"],"ProfileName") == nil ) then
					printCLIError("Invalid BandwidthProfile.")
					return false
				end
			end
			if (configRow["FirewallRules.SNATAddressType"] == nil or configRow["FirewallRules.SNATAddressType"] == "" )then
				printCLIError("Enter Snat_address_Type.")
				return false
			elseif (configRow["FirewallRules.SNATAddressType"] == "1" ) then
				if ( configRow["FirewallRules.SNATAddress"] == nil or configRow["FirewallRules.SNATAddress"] == "" or configRow["FirewallRules.SNATAddress"] == "0.0.0.0") then
					printCLIError("Enter nat_ip.")
					return false
				end
			end
		end
		
	--      DMZ WAN OUTBOUND CASE
	--
	elseif ( configRow["FirewallRules.FromZoneType"] == "PUBLIC" and configRow["FirewallRules.ToZoneType"] == "INSECURE") then
			if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil and configRow["FirewallRules.SourceAddressType"] == nil) then
			printCLIError("source_address_type group_wise not applicable")
			return false
		end
		if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil and configRow["FirewallRules.DestinationAddressType"] == nil) then
			printCLIError("destination_address_type group_wise not applicable")
			return false
		end
		if(configRow["FirewallRules.SourceAddressType"] == nil or configRow["FirewallRules.SourceAddressType"] == "") then printCLIError("Please Enter source_address_type.") ; return false ; end
		if(configRow["FirewallRules.DestinationAddressType"] == nil or configRow["FirewallRules.DestinationAddressType"] == "") then printCLIError("Please Enter destination_address_type.") ; return false ; end
		if ( configRow["FirewallRules.Action"] ~= "DROP" ) then
			if ( configRow["FirewallRules.TypeOfService"] == nil or configRow["FirewallRules.TypeOfService"] == "") then
				printCLIError("Please Select qos_priority.")
				return false
			end
			if ( configRow["FirewallRules.BandwidthProfileName"] ~= nil) then
				if ( db.getAttribute("BandWidthProfile","ProfileName",configRow["FirewallRules.BandwidthProfileName"],"ProfileName") == nil ) then
					printCLIError("Invalid BandwidthProfile.")
					return false
				end
			end
			if (configRow["FirewallRules.SNATAddressType"] == nil or configRow["FirewallRules.SNATAddressType"] == "" )then
				printCLIError("Enter nat_ip type.")
				return false
			elseif (configRow["FirewallRules.SNATAddressType"] == "1" ) then
				if ( configRow["FirewallRules.SNATAddress"] == nil or configRow["FirewallRules.SNATAddress"] == "" or configRow["FirewallRules.SNATAddress"] == "0.0.0.0" ) then
					printCLIError("Enter nat_ip.")
					return false
				end
			end	
		end

	
	--      LAN DMZ OUTBOUND and INBOUND CASE
	--
	elseif (configRow["FirewallRules.FromZoneType"] == "SECURE" and configRow["FirewallRules.ToZoneType"] == "PUBLIC" )then
		if(configRow["FirewallRules.SourceAddressType"] == nil and configRow["FirewallRules.SourceAddressTypeG"] == nil)then printCLIError("Please Select source_address_type.") ; return false ; end
		if(configRow["FirewallRules.DestinationAddressType"] == nil and configRow["FirewallRules.DestinationAddressTypeG"] == nil)then printCLIError("Please Select destination_address_type.") ; return false ; end
--		if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT MODE or Classical Routing
			if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil )then --SourceAddressType is LAN Groups
				local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.SourceAddressTypeG"],"rowid")
				if( LanGroupRowId == nil )then
					printCLIError("Lan Group Does not exist.")
					return false
				else
					configRow["FirewallRules.SourceAddressType"] = tonumber(LanGroupRowId) +2
				end
			end
			if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil and configRow["FirewallRules.DestinationAddressType"] == nil)then --SourceAddressType is LAN Groups
				printCLIError("destination_address_type group_wise not applicable.")
				return false
			end
--		end


	elseif ( configRow["FirewallRules.FromZoneType"] == "PUBLIC" and configRow["FirewallRules.ToZoneType"] == "SECURE" ) then
		if(configRow["FirewallRules.SourceAddressType"] == nil and configRow["FirewallRules.SourceAddressTypeG"] == nil)then printCLIError("Please Select source_address_type.") ; return false ; end
		if(configRow["FirewallRules.DestinationAddressType"] == nil and configRow["FirewallRules.DestinationAddressTypeG"] == nil)then printCLIError("Please Select destination_address_type.") ; return false ; end
--		if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT MODE or Classical Routing
			if(configRow["FirewallRules.DestinationAddressTypeG"] ~= nil )then --DestinationAddressType is LAN Groups
				local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.DestinationAddressTypeG"],"rowid")
				if( LanGroupRowId == nil )then
					printCLIError("Lan Group Does not exist.")
					return false
				else
					configRow["FirewallRules.DestinationAddressType"] = tonumber(LanGroupRowId) +2
				end
			end
			if(configRow["FirewallRules.SourceAddressTypeG"] ~= nil and configRow["FirewallRules.SourceAddressType"] == nil)then --SourceAddressType is LAN Groups
				printCLIError("source_address_type group_wise not applicable.")
				return false
			end
--		end

	end	
	if ( configRow["FirewallRules.BandwidthProfileName"] ~= nil) then
		if ( db.getAttribute("BandWidthProfile","ProfileName",configRow["FirewallRules.BandwidthProfileName"],"ProfileName") == nil ) then
			printCLIError("Invalid BandwidthProfile.")
			return false
		end
	end
    return true
end

--{
--lan-wan config function
function accessControlLWRuleCfgInit(args)
	local configRow={}
	local rowId = args[1]
	if(rowId == nil )then
	--initialization of default values
	       	configRow["FirewallRules.Status"] = "1"
		configRow["FirewallRules.RuleType"] = "SECURE_INSECURE"
		configRow["FirewallRules.FromZoneType"] = "SECURE"
		configRow["FirewallRules.ToZoneType"] = "INSECURE"
		configRow["FirewallRules.ServiceName"] = "ANY"
		configRow["FirewallRules.SourceAddressType"] = "0" --Any
		configRow["FirewallRules.DestinationAddressType"] = "0" --Any
		configRow["FirewallRules.Action"] = "DROP" --Block Always
		configRow["FirewallRules.LogLevel"] = "1" --Never
		configRow["FirewallRules._ROWID_"] = "-1"
        configRow["FirewallRules.QosProfileName"] = "None"
        --added
        configRow["FirewallRules.DscpMark"] = "Custom"
	else
		--initialization for edit case
        	configRow= db.getRow("FirewallRules","_ROWID_",rowId)
	        if (configRow == nil) then
          		print("Row does not exist")          
           		return -1
        	end

        if(configRow["FirewallRules.SNATAddressType"] == "1" and configRow["FirewallRules.SNATAddress"] ~= nil and configRow["FirewallRules.SNATAddress"] ~= '') then       
            configRow["FirewallRules.SNATAddressType"] = configRow["FirewallRules.SNATAddress"]
        elseif(configRow["FirewallRules.SNATAddressType"] == "1" and (configRow["FirewallRules.SNATAddress"] == nil or configRow["FirewallRules.SNATAddress"] == '')) then
            configRow["FirewallRules.SNATAddressType"] = configRow["FirewallRules.SNATInterface"]
        end
        if(configRow["FirewallRules.QosProfileName"] == "0") then
            configRow["FirewallRules.QosProfileName"] = "None"
        end
        if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
        configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
            local id = tonumber(configRow["FirewallRules.SourceAddressType"]) - 2
		    local LanGroupName = db.getAttribute("LanGroup","rowid",id,"GroupName")
		    if( LanGroupName == nil )then
                local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.SourceAddressType"] .. " AND ipGroupType=0")
                if (ipGroupId ~= nil) then
			        configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupName"]
                end
		    else
			    configRow["FirewallRules.SourceAddressType"] = LanGroupName
		    end
	    end
        if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.DestinationAddressType"] .. " AND ipGroupType=1")
            if (ipGroupId ~= nil) then
		        configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupName"]
            end
	    end
		if(configRow["FirewallRules.RuleType"] ~= "SECURE_INSECURE")then 
			printCLIError("Rule is not lan-wan outbound rule. Edit will not be effective.")
           		return -1
		end
		return rowId,configRow
    	end	
	    	return -1,configRow

end

function accessControlLWRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    --default value initialization before save
    if(configRow["FirewallRules.Action"] ~= "DROP" and db.getAttribute("NatTable","rowid","1","Enable") == "1")then
	if(configRow["FirewallRules.SNATAddressType"] == nil or configRow["FirewallRules.SNATAddressType"] == "") then 
		configRow["FirewallRules.SNATAddressType"] = "7" 
	end
    end
    if(configRow["FirewallRules.BandwidthProfileName"] == "" or configRow["FirewallRules.BandwidthProfileName"] == nil)then
	if(configRow["FirewallRules.Action"] ~= "DROP")then
	    configRow["FirewallRules.BandwidthProfileName"] = "NONE"
	end
    end
    local serviceRow = db.getRow ("Services", "ServiceName", configRow["FirewallRules.ServiceName"])    	
    if(serviceRow ~= nil and serviceRow["Services.IsDefault"] == "0") then    		
        configRow["FirewallRules.TypeOfService"] = serviceRow["Services.TypeOfService"]
    end
    if (configRow["FirewallRules._ROWID_"] == "-1") then
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()
    end
    return errorFlag, statusMessage	
end

function accessControlLWRuleCfgInputVal(configRow)
	if (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
    if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end


	if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
       configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
		local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.SourceAddressType"],"rowid")
		if( LanGroupRowId == nil )then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.SourceAddressType"] .. "' AND ipGroupType=0")
            if (ipGroupId == nil) then
			    printCLIError("Lan Group Does not exist.")
			    return false
            else
			    configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupId"]
            end
		else
			configRow["FirewallRules.SourceAddressType"] = tonumber(LanGroupRowId) +2
		end
	end
    if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
       configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
        local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.DestinationAddressType"] .. "' AND ipGroupType=1")
        if (ipGroupId == nil) then
		    printCLIError("Wan Group Does not exist.")
		    return false
        else
		    configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupId"]
        end
	end
	--[[if (db.getRowWhere("Services","ServiceName ='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault = 0") ~= nil and configRow["FirewallRules.TypeOfService"] ~= nil) then
		printCLIError("qos_priority of custom service can't be changed.")
		return false
	end]]--
	if ( configRow["FirewallRules.BandwidthProfileName"] ~= nil and configRow["FirewallRules.BandwidthProfileName"] ~= "" and configRow["FirewallRules.BandwidthProfileName"] ~= "NONE") then
		if ( db.getAttribute("BandWidthProfile","ProfileName",configRow["FirewallRules.BandwidthProfileName"],"ProfileName") == nil ) then
			printCLIError("Invalid BandwidthProfile.")
			return false
		end
	end
	if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT MODE
		if(configRow["FirewallRules.SNATAddressType"] ~= nil) then
            if(configRow["FirewallRules.SNATAddressType"] ~= "7") then
                if(configRow["FirewallRules.SNATAddressType"] ~= "WAN1" and 
                   configRow["FirewallRules.SNATAddressType"] ~= "WAN2" and
                   configRow["FirewallRules.SNATAddressType"] ~= "WAN3" and
                   configRow["FirewallRules.SNATAddressType"] ~= "WAN4") then
                    configRow["FirewallRules.SNATAddress"] = configRow["FirewallRules.SNATAddressType"]
                    configRow["FirewallRules.SNATAddressType"] = "1"
                    local ipAddress = configRow["FirewallRules.SNATAddress"]
                    if (db.existsRowWhere("ifStaticIPAlias","LogicalIfName!='LAN' AND IPAddress='"..ipAddress.."'")) then
                        configRow["FirewallRules.SNATInterface"] = db.getAttribute ("ifStaticIPAlias", "IPAddress", ipAddress, "LogicalIfName")
                    else
                        printCLIError ("Nat IP doesn't exists in any WAN secondary addresses. Please select from following IP Addresses")
                        local natIpTable = db.getRowsWhere("ifStaticIPAlias","LogicalIfName!='LAN'")
                        local i = 0
                        for k,v in pairs(natIpTable) do
                            i = i + 1
                            local natIp = natIpTable[i]
                            if (natIp ~= nil) then
                                print("'"..natIp["ifStaticIPAlias.IPAddress"].."'")
                            end
                        end
                        return false
                    end
                else
                    configRow["FirewallRules.SNATInterface"] = configRow["FirewallRules.SNATAddressType"]
                    configRow["FirewallRules.SNATAddress"] = ''
                    configRow["FirewallRules.SNATAddressType"] = "1"
                end
            end
        end
	else
		--classical routing
        if(configRow["FirewallRules._ROWID_"] == "-1") then
			--if(configRow["FirewallRules.SNATAddress"] ~= nil and configRow["FirewallRules.SNATAddress"] ~= "")then
				--printCLIError("nat_ip is not applicable in classical routing.")
				--return false
			--end
			if(configRow["FirewallRules.SNATAddressType"] ~= nil and configRow["FirewallRules.SNATAddressType"] ~= "")then
				printCLIError("nat_ip in classical routing is not applicable.")
				return false
			end
        end
	end
	--address range validation
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" or configRow["FirewallRules.SourceAddressStart"] == "0.0.0.0") then
			printCLIError("Enter lan_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" or configRow["FirewallRules.SourceAddressEnd"] == "0.0.0.0") then
			    printCLIError("Enter lan_user_end_ip.")
			    return false
            end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for Lan Users")
                return false
            end
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
		if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == ""or configRow["FirewallRules.DestinationAddressStart"] == "0.0.0.0" ) then
			printCLIError("Enter wan_user_start_ip.")
			return false
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "2")then
		if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
			printCLIError("Enter wan_user_end_ip.")
			return false
		end
        local status = ''
        status = ifDev.ipSubnet(configRow["FirewallRules.DestinationAddressStart"],"255.255.0.0",configRow["FirewallRules.DestinationAddressStart"],configRow["FirewallRules.DestinationAddressEnd"])
        if (status == "Error: Start IP can't be greater than End IP") then
            printCLIError (status.." for Wan Users")
            return false
        end
	end
	if(configRow["FirewallRules.Action"] =="DROP" and configRow["FirewallRules._ROWID_"] == "-1")then
	    --if action is block always
		--if(configRow["FirewallRules.SNATAddress"] ~= "" and configRow["FirewallRules.SNATAddress"] ~= nil )then
			--printCLIError("nat_ip address is not applicable when action is block always.")
			--return false
		--end
		--[[if(configRow["FirewallRules.TypeOfService"] ~= "" and configRow["FirewallRules.TypeOfService"] ~= nil )then
		    printCLIError("When action is block always then qos_priority is not applicable.")
		    return false
		end]]--
		if(configRow["FirewallRules.BandwidthProfileName"] ~= "" and configRow["FirewallRules.BandwidthProfileName"] ~= nil and configRow["FirewallRules.BandwidthProfileName"] ~= "NONE")then
		    printCLIError("When action is block always then bandwidth profile is not applicable.")
		    return false
		end
		if(configRow["FirewallRules.SNATAddressType"] ~= "" and configRow["FirewallRules.SNATAddressType"] ~= nil )then
		    printCLIError("When action is block always then nat ip option is not applicable.")
		    return false
		end
	end
	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end	
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
	if(configRow["FirewallRules.ScheduleName"] ~= nil and configRow["FirewallRules.ScheduleName"] ~= "")then
	    if(configRow["FirewallRules.Action"] ~= "DROP_BY_SCHEDULE" and configRow["FirewallRules.Action"] ~= "ACCEPT_BY_SCHEDULE")then
		printCLIError("Schedule is not applicable.")
		return false
	    end
	end	
	if(configRow["FirewallRules.SourceAddressStart"] ~= nil and configRow["FirewallRules.SourceAddressStart"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("lan_user_start_ip is applicable only when lan_users is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressEnd"] ~= nil and configRow["FirewallRules.SourceAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("lan_user_end_ip is applicable only when lan_users is ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressStart"] ~= nil and configRow["FirewallRules.DestinationAddressStart"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("wan_user_start_ip is applicable only when wan_users  is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressEnd"] ~= nil and configRow["FirewallRules.DestinationAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("wan_user_end_ip is applicable only when wan_users  is  ADDRESS_RANGE.")
		return false
	    end
	end
	--if(configRow["FirewallRules.SNATAddress"] ~= nil and configRow["FirewallRules.SNATAddress"] ~= "")then
	    --if(configRow["FirewallRules.SNATAddressType"] ~= "1")then
		--printCLIError("nat ip is applicable only when nat type SINGLE_ADDRESS is selected.")
		--return false
	    --end
	--end
    end
    if(configRow["FirewallRules.Action"] ~= "DROP")then
        local QosProfileRow = {}
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil) then
            QosProfileRow = db.getRow ("qosProfile","ProfileName",configRow["FirewallRules.QosProfileName"])
        end
        if (configRow["FirewallRules.QosProfileName"] == "" or configRow["FirewallRules.QosProfileName"] == nil or
           (configRow["FirewallRules.QosProfileName"] ~= "None" and QosProfileRow == nil)) then
            printCLIError("Invalid qos_profile name.Please select from following QoS Profiles")
            print("'None'")
            local qosTable = db.getTable("qosProfile")
            local i = 0
            for k,v in pairs(qosTable) do
                i = i + 1
                local qos = qosTable[i]
                if (qos ~= nil) then
                    print("'"..qos["qosProfile.ProfileName"].."'")
                end
            end
            return false
        end
        if (configRow["FirewallRules.QosProfileName"] == "None") then
            configRow["FirewallRules.QosProfileName"] = "0"
        end
    else
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil and
            configRow["FirewallRules.QosProfileName"] ~= "None" and configRow["FirewallRules._ROWID_"] == "-1") then
            printCLIError ("Qos Profile is not applicable when Action is ALWAYS_BLOCK")
            return false
        end
    end
   if (configRow["FirewallRules.RuleType"] == "SECURE_INSECURE" and configRow["FirewallRules.ServiceName"] == "ANY" and configRow["FirewallRules.SourceAddressType"] == "0" and configRow["FirewallRules.DestinationAddressType"] == "0" and configRow["FirewallRules.Action"] == "DROP" and configRow["FirewallRules.LogLevel"] == "1" and configRow["FirewallRules.QosProfileName"] == "None") then
        configRow["FirewallRules.DscpMark"] = "Default"
    
    if (db.existsRowWhere("FirewallRules", "RuleType='SECURE_INSECURE' AND DscpMark ='Default'")) then
       printCLIError("This rule already exists!")
        return false
    end
    end

	return true	
end

--wan-lan config function
function accessControlWLRuleCfgInit(args)
	local configRow={}
	--initialization
	local rowId = args[1]
    	if (rowId == nil) then
		--initialization for add case
	   	configRow["FirewallRules.Status"] = "1"
		configRow["FirewallRules.RuleType"] = "INSECURE_SECURE"
		configRow["FirewallRules.FromZoneType"] = "INSECURE"
		configRow["FirewallRules.ToZoneType"] = "SECURE"
		configRow["FirewallRules.ServiceName"] = "ANY"
		configRow["FirewallRules.SourceAddressType"] = "0" --Any
		configRow["FirewallRules.Action"] = "DROP" --Block Always
		configRow["FirewallRules.LogLevel"] = "1" --Never
		configRow["FirewallRules._ROWID_"] = "-1"
        configRow["FirewallRules.QosProfileName"] = "None"
        --added
        configRow["FirewallRules.DscpMark"] = "Custom"
		--initialization according to WAN mode(NAT or Classical Routing.)
		local wanMode = db.getAttribute("NatTable","rowid","1","Enable") or '1'	
		if(wanMode == "1")then --nat
			configRow["FirewallRules.DestinationPublicInterface"] = "WAN1" --Broadband
		elseif(wanMode == "0")then --classical routing
			configRow["FirewallRules.DestinationAddressType"] = "0" --Any	
			configRow["FirewallRules.DNATPortEnable"] = "0" --DNAT Port Disabled
		end
	else
		--initialization for edit case
		configRow= db.getRow("FirewallRules","_ROWID_",rowId)
		if (configRow == nil) then
          		print("Row does not exist")          
           		return -1
        	end
        if(configRow["FirewallRules.QosProfileName"] == "0") then
            configRow["FirewallRules.QosProfileName"] = "None"
        end
        if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
            local id = tonumber(configRow["FirewallRules.DestinationAddressType"]) - 2
		    local LanGroupName = db.getAttribute("LanGroup","rowid",id,"GroupName")
		    if( LanGroupName == nil )then
                local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.DestinationAddressType"] .. " AND ipGroupType=0")
                if (ipGroupId ~= nil) then
			        configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupName"]
                end
		    else
			    configRow["FirewallRules.DestinationAddressType"] = LanGroupName
		    end
	    end
        if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
        configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.SourceAddressType"] .. " AND ipGroupType=1")
            if (ipGroupId ~= nil) then
		        configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupName"]
            end
	    end
		if(configRow["FirewallRules.RuleType"] ~= "INSECURE_SECURE")then 
			printCLIError("Rule is not lan-wan inbound rule. Edit will not be effective.")
           		return -1
		end
		return rowId,configRow
	end
    	return -1,configRow
end


function accessControlWLRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    if(configRow["FirewallRules.BandwidthProfileName"] == "" or configRow["FirewallRules.BandwidthProfileName"] == nil)then
	if(configRow["FirewallRules.Action"] ~= "DROP")then
	    configRow["FirewallRules.BandwidthProfileName"] = "NONE"
	end
    end
    if (configRow["FirewallRules._ROWID_"] == "-1") then
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()
    end
    return errorFlag, statusMessage	
end


function accessControlWLRuleCfgInputVal(configRow)
	if (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
     if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end
    if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
       configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
        local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.SourceAddressType"] .. "' AND ipGroupType=1")
        if (ipGroupId == nil) then
		    printCLIError("Wan Group Does not exist.")
		    return false
        else
		    configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupId"]
        end
	end
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" or configRow["FirewallRules.SourceAddressStart"] == "0.0.0.0") then
			printCLIError("Enter wan_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" or configRow["FirewallRules.SourceAddressType"] == "0.0.0.0") then
		        printCLIError("Enter wan_user_end_ip.")
			    return false
            end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for Wan Users")
                return false
            end
		end
	end	
	if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT
		if (configRow["FirewallRules.DNATPortEnable"] == "1" and (configRow["FirewallRules.DNATPort"] == nil or configRow["FirewallRules.DNATPort"] == "")) then
			printCLIError("Enter the dnat_port.")
			return false
		end
        if(configRow["FirewallRules._ROWID_"] == "-1") then
		if(configRow["FirewallRules.DestinationAddressType"]~=nil)then
			printCLIError("lan_users is not applicable.")
			return false
		end
		if(configRow["FirewallRules.DestinationAddressStart"]~=nil and configRow["FirewallRules.DestinationAddressStart"] ~= "")then
			printCLIError("lan_user_start_ip  is not applicable.")
			return false
		end
		if(configRow["FirewallRules.DestinationAddressEnd"]~=nil and configRow["FirewallRules.DestinationAddressEnd"] ~= "")then
			printCLIError("lan_user_end_ip  is not applicable.")
			return false
		end
        end
	    if(configRow["FirewallRules.Action"]~="DROP")then
		if ( configRow["FirewallRules.DNATAddressType"] == nil or configRow["FirewallRules.DNATAddressType"] == "") then
			printCLIError("Please select option for send_to_lan_server.")
			return false
		elseif ( configRow["FirewallRules.DNATAddressType"] == "1" or configRow["FirewallRules.DNATAddressType"] == "2") then
			if ( configRow["FirewallRules.DNATAddress"] == nil or  configRow["FirewallRules.DNATAddress"] == "" ) then
				printCLIError("Please enter send_to_lan_server_start_ip.")
				return false
			end
			if ( configRow["FirewallRules.DNATAddressType"] == "2") then
                if ( configRow["FirewallRules.DNATAddressEnd"] == nil or configRow["FirewallRules.DNATAddressEnd"] == ""or configRow["FirewallRules.DNATAddressEnd"] == "0.0.0.0" ) then 
				    printCLIError("Please Enter send_to_lan_server_end_ip.")
				    return false
			    end
                local status = ''
                status = ifDev.ipSubnet(configRow["FirewallRules.DNATAddress"],"255.255.0.0",configRow["FirewallRules.DNATAddress"],configRow["FirewallRules.DNATAddressEnd"])
                if (status == "Error: Start IP can't be greater than End IP") then
                    printCLIError (status.." for Send to Lan Server")
                    return false
                end
            end
		end
	      --if(configRow["FirewallRules.Action"]~="DROP")then
        if (configRow["FirewallRules.DNATAddressType"] == "2" ) then
			if ( configRow["FirewallRules.DestinationPublicInterface"] ~= "RANGE") then
				printCLIError("If send_to_lan_server is RANGE then wan_destination_ip will be RANGE. ")
				return false
			end
		end
        end
		if (configRow["FirewallRules.DestinationPublicInterface"] == nil or configRow["FirewallRules.DestinationPublicInterface"] == "") then 
			printCLIError("Please select option for wan_destination_ip.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "OTHER" and ( configRow["FirewallRules.DestinationPublicAddress"] == nil or configRow["FirewallRules.DestinationPublicAddress"] == ""or configRow["FirewallRules.DestinationPublicAddress"] == "0.0.0.0")) then
			printCLIError("Enter the wan_destination_ip_start.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "RANGE") then
			if( configRow["FirewallRules.DestinationPublicAddressEnd"] == nil or configRow["FirewallRules.DestinationPublicAddressEnd"] == ""or configRow["FirewallRules.DestinationPublicAddressEnd"] == "0.0.0.0") then
				printCLIError("Enter the wan_destination_ip_address_end.")
				return false
			end
			if( configRow["FirewallRules.DestinationPublicAddress"] == nil or configRow["FirewallRules.DestinationPublicAddress"] == "" or configRow["FirewallRules.DestinationPublicAddress"] == "0.0.0.0") then
				printCLIError("Enter the wan_destination_ip_address_start.")
				return false
			end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.DestinationPublicAddress"],"255.255.0.0",configRow["FirewallRules.DestinationPublicAddress"],configRow["FirewallRules.DestinationPublicAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for Wan Destination")
                return false
            end
		end
	    if(configRow["FirewallRules.Action"]~="DROP")then
        if (configRow["FirewallRules.DNATAddressType"] == "2" and configRow["FirewallRules.DestinationPublicInterface"] == "RANGE") then
            local range1 = ifDev.ipAddrRange (configRow["FirewallRules.DNATAddress"], configRow["FirewallRules.DNATAddressEnd"])
            local range2 = ifDev.ipAddrRange (configRow["FirewallRules.DestinationPublicAddress"], configRow["FirewallRules.DestinationPublicAddressEnd"])
            if (range1 ~= range2) then
                printCLIError("Range mismatch in WAN Destination IP addresses and LAN server IP addresses")
				return false
			end
        end
        end
	      --else
		  --if action is drop
		  --if (configRow["FirewallRules.DestinationPublicInterface"] =="OTHER" or  configRow["FirewallRules.DestinationPublicInterface"] =="RANGE" )then
		      --printCLIError("wan_destination_ip_address is not applicable when action is block.")
		      --return false
		  --end
		  --if (configRow["FirewallRules.DestinationPublicAddress"] ~= "" and  configRow["FirewallRules.DestinationPublicAddress"] ~= nil )then
		      --printCLIError("wan_destination_ip_address_start is not applicable when action is block.")
		      --return false
		  --end
		  --if (configRow["FirewallRules.DestinationPublicAddressEnd"] ~= "" and  configRow["FirewallRules.DestinationPublicAddressEnd"] ~= nil )then
		      --printCLIError("wan_destination_ip_address_end is not applicable when action is block.")
		      --return false
		  --end
	      --end
	else 					--classical routing
		if(configRow["FirewallRules.DestinationAddressType"] == nil)then printCLIError("Please enter lan_user.") ; return false ; end
		if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
				local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.DestinationAddressType"],"rowid")
				if( LanGroupRowId == nil )then
					local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.DestinationAddressType"] .. "' AND ipGroupType=0")
                    if (ipGroupId == nil) then
			            printCLIError("Lan Group Does not exist.")
			            return false
                    else
			            configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupId"]
                    end
				else
					configRow["FirewallRules.DestinationAddressType"] = tonumber(LanGroupRowId) +2
				end
			end	
        if(configRow["FirewallRules._ROWID_"] == "-1") then
			if (configRow["FirewallRules.DNATAddressType"] == "1" or configRow["FirewallRules.DNATAddressType"] == "2") then
				printCLIError("nat options are not applicable in case of classical routing.")
				return false
			end
			if(configRow["FirewallRules.DNATAddressType"] == "1" or configRow["FirewallRules.DNATAddressType"] == "2" )then
				printCLIError("send_to_lan_server is not applicable in classical routing.")
				return false
			end
			if(configRow["FirewallRules.DNATAddress"] ~= "" and configRow["FirewallRules.DNATAddress"] ~=nil  )then
				printCLIError("send_to_lan_server_start_ip is not applicable in classical routing.")
				return false
			end
			if(configRow["FirewallRules.DNATAddressEnd"] ~= "" and configRow["FirewallRules.DNATAddressEnd"] ~=nil )then
				printCLIError("send_to_lan_server_end_ip is not applicable in classical routing.")
				return false
			end
			if(configRow["FirewallRules.DNATPortEnable"] == "1")then
				printCLIError("translate_to_port_no is not applicable.")
				return false
			end
			if(configRow["FirewallRules.DNATPort"] ~= "" and configRow["FirewallRules.DNATPort"] ~= nil)then
				printCLIError("translate_to_port_no port is not applicable.")
				return false
			end
			if(configRow["FirewallRules.DestinationPublicInterface"] ~= "" and configRow["FirewallRules.DestinationPublicInterface"] ~= nil)then
				printCLIError("wan_destination_ip_address is not applicable.")
				return false
			end
			if(configRow["FirewallRules.DestinationPublicAddress"] ~= "" and configRow["FirewallRules.DestinationPublicAddress"] ~= nil)then
				printCLIError("wan_destination_ip_address_start is not applicable.")
				return false
			end
			if(configRow["FirewallRules.DestinationPublicAddressEnd"] ~= "" and configRow["FirewallRules.DestinationPublicAddressEnd"] ~= nil)then
				printCLIError("wan_destination_ip_address_end is not applicable.")
				return false
			end
        end
	end	
	if ( configRow["FirewallRules.BandwidthProfileName"] ~= nil and configRow["FirewallRules.BandwidthProfileName"] ~= "" and configRow["FirewallRules.BandwidthProfileName"] ~= "NONE") then
		if ( db.getAttribute("BandWidthProfile","ProfileName",configRow["FirewallRules.BandwidthProfileName"],"ProfileName") == nil ) then
			printCLIError("Invalid BandwidthProfile.")
			return false
		end
	end
	if(configRow["FirewallRules.Action"]=="DROP" and configRow["FirewallRules.BandwidthProfileName"]~=nil and configRow["FirewallRules._ROWID_"] == "-1")then
		printCLIError("bandwidth_profile is not applicable when action is block always.")
		return false
	end
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" or configRow["FirewallRules.SourceAddressStart"] == "0.0.0.0") then
			printCLIError("Enter wan_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" or configRow["FirewallRules.SourceAddressEnd"] == "0.0.0.0") then
			    printCLIError("Enter wan_user_end_ip.")
			    return false
            end

            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for Wan Users")
                return false
            end
        end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
		if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == "" or configRow["FirewallRules.DestinationAddressStart"] == "0.0.0.0") then
			printCLIError("Enter lan_user_start_ip.")
			return false
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "2")then
		if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
			printCLIError("Enter lan_user_end_ip.")
			return false
		end
        local status = ''
        status = ifDev.ipSubnet(configRow["FirewallRules.DestinationAddressStart"],"255.255.0.0",configRow["FirewallRules.DestinationAddressStart"],configRow["FirewallRules.DestinationAddressEnd"])
        if (status == "Error: Start IP can't be greater than End IP") then
            printCLIError (status.." for Lan Users")
            return false
        end
	end
	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end	
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
	if(configRow["FirewallRules.ScheduleName"] ~= nil and configRow["FirewallRules.ScheduleName"] ~= "")then
	    if(configRow["FirewallRules.Action"] ~= "DROP_BY_SCHEDULE" and configRow["FirewallRules.Action"] ~= "ACCEPT_BY_SCHEDULE")then
		printCLIError("Schedule is not applicable.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressStart"] ~= nil and configRow["FirewallRules.SourceAddressStart"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("wan_user_start_ip is applicable only when wan_users is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressEnd"] ~= nil and configRow["FirewallRules.SourceAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("wan_user_end_ip is applicable only when wan_users is ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressStart"] ~= nil and configRow["FirewallRules.DestinationAddressStart"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("lan_user_start_ip is applicable only when lan_users is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressEnd"] ~= nil and configRow["FirewallRules.DestinationAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("lan_user_end_ip is applicable only when lan_users is ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DNATAddress"] ~= nil and configRow["FirewallRules.DNATAddress"] ~= "")then
	    if(configRow["FirewallRules.DNATAddressType"] ~= "1" and configRow["FirewallRules.DNATAddressType"] ~= "2")then
		printCLIError("send_to_lan_server_start_ip is applicable only when send_to_lan_server is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DNATAddressEnd"] ~= nil and configRow["FirewallRules.DNATAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.DNATAddressType"] ~= "2")then
		printCLIError("send_to_lan_server_start_ip is applicable only when send_to_lan_server is ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationPublicAddress"] ~= nil and configRow["FirewallRules.DestinationPublicAddress"] ~= "")then
	    if(configRow["FirewallRules.DestinationPublicInterface"] ~= "OTHER" and configRow["FirewallRules.DestinationPublicInterface"] ~= "RANGE")then
		printCLIError("wan_destination_ip_address_start is applicable only when wan_destination_ip_address is OTHER or RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationPublicAddressEnd"] ~= nil and configRow["FirewallRules.DestinationPublicAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.DestinationPublicInterface"] ~= "RANGE")then
		printCLIError("wan_destination_ip_address_start is applicable only when wan_destination_ip_address is RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DNATPort"] ~= nil and configRow["FirewallRules.DNATPort"] ~= "")then
	    if(configRow["FirewallRules.DNATPortEnable"] ~= "1")then
		printCLIError("Please enable translate_to_port_no.")
		return false
	    end
	end
    end
    if(configRow["FirewallRules.Action"] ~= "DROP")then
        local QosProfileRow = {}
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil) then
            QosProfileRow = db.getRow ("qosProfile","ProfileName",configRow["FirewallRules.QosProfileName"])
        end
        if (configRow["FirewallRules.QosProfileName"] == "" or configRow["FirewallRules.QosProfileName"] == nil or
           (configRow["FirewallRules.QosProfileName"] ~= "None" and QosProfileRow == nil)) then
            printCLIError("Invalid qos_profile name.Please select from following QoS Profiles")
            print("'None'")
            local qosTable = db.getTable("qosProfile")
            local i = 0
            for k,v in pairs(qosTable) do
                i = i + 1
                local qos = qosTable[i]
                if (qos ~= nil) then
                    print("'"..qos["qosProfile.ProfileName"].."'")
                end
            end
            return false
        end
        if (configRow["FirewallRules.QosProfileName"] == "None") then
            configRow["FirewallRules.QosProfileName"] = "0"
        end
    else
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil and
            configRow["FirewallRules.QosProfileName"] ~= "None" and configRow["FirewallRules._ROWID_"] == "-1") then
            printCLIError ("Qos Profile is not applicable when Action is ALWAYS_BLOCK")
            return false
        end
    end
    if (configRow["FirewallRules.RuleType"] == "INSECURE_SECURE" and configRow["FirewallRules.ServiceName"] == "ANY" and configRow["FirewallRules.SourceAddressType"] == "0" and	configRow["FirewallRules.Action"] == "DROP" and	configRow["FirewallRules.LogLevel"] == "1" and configRow["FirewallRules.QosProfileName"] == "None" and configRow["FirewallRules.DestinationPublicInterface"] == "WAN1") then
 configRow["FirewallRules.DscpMark"] = "Default"
    
    if (db.existsRowWhere("FirewallRules", "RuleType='INSECURE_SECURE' AND DscpMark ='Default'")) then
       printCLIError("This rule already exists!")
        return false
    end
    end

	return true
end


--dmz-wan config function
function accessControlDWRuleCfgInit(args)
	local configRow={}
		--initialization of default values
   	local rowId = args[1]
    	if (rowId == nil) then
		--initialization for add case
	       	configRow["FirewallRules.Status"] = "1"
		configRow["FirewallRules.RuleType"] = "PUBLIC_INSECURE"
		configRow["FirewallRules.FromZoneType"] = "PUBLIC"
		configRow["FirewallRules.ToZoneType"] = "INSECURE"
		configRow["FirewallRules.ServiceName"] = "ANY"
		configRow["FirewallRules.SourceAddressType"] = "0" --Any
		configRow["FirewallRules.DestinationAddressType"] = "0" --Any
		configRow["FirewallRules.Action"] = "DROP" --Block Always
		configRow["FirewallRules.LogLevel"] = "1" --Never
        configRow["FirewallRules.SNATInterface"] = "WAN1"
		configRow["FirewallRules._ROWID_"] = "-1"
        configRow["FirewallRules.QosProfileName"] = "None"
        --added
        configRow["FirewallRules.DscpMark"] = "Custom"
	else
		--initialization for edit case
		configRow= db.getRow("FirewallRules","_ROWID_",rowId)
	        if (configRow == nil) then
          		print("Row does not exist")          
           		return -1
        	end

        if(configRow["FirewallRules.SNATAddressType"] == "1" and configRow["FirewallRules.SNATAddress"] ~= nil and configRow["FirewallRules.SNATAddress"] ~= '') then       
            configRow["FirewallRules.SNATAddressType"] = configRow["FirewallRules.SNATAddress"]
        elseif(configRow["FirewallRules.SNATAddressType"] == "1" and (configRow["FirewallRules.SNATAddress"] == nil or configRow["FirewallRules.SNATAddress"] == '')) then
            configRow["FirewallRules.SNATAddressType"] = configRow["FirewallRules.SNATInterface"]
        end
        if(configRow["FirewallRules.QosProfileName"] == "0") then
            configRow["FirewallRules.QosProfileName"] = "None"
        end
        if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.DestinationAddressType"] .. " AND ipGroupType=1")
            if (ipGroupId ~= nil) then
		        configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupName"]
            end
	    end
		if(configRow["FirewallRules.RuleType"] ~= "PUBLIC_INSECURE")then 
			printCLIError("Rule is not dmz-wan outbound rule. Edit will not be effective.")
			return -1
		end
		return rowId,configRow
	end
    	return -1,configRow
end


function accessControlDWRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    local serviceRow = db.getRow ("Services", "ServiceName", configRow["FirewallRules.ServiceName"])    	
    if(serviceRow ~= nil and serviceRow["Services.IsDefault"] == "0") then    		
        configRow["FirewallRules.TypeOfService"] = serviceRow["Services.TypeOfService"]
    end
    if (configRow["FirewallRules._ROWID_"] == "-1") then
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()
    end
    return errorFlag, statusMessage	
end


function accessControlDWRuleCfgInputVal(configRow)
	if (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
	if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end
	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end
    else
        if(configRow["FirewallRules._ROWID_"] == "-1") then
		if (configRow["FirewallRules.ScheduleName"] ~= nil and configRow["FirewallRules.ScheduleName"] ~= "")then
			printCLIError("schedule name option is not applicable if Action field is ALWAYS_ALLOW or ALWAYS_BLOCK.")
			return false
		end
        end
	end
    if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
        local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.DestinationAddressType"] .. "' AND ipGroupType=1")
        if (ipGroupId == nil) then
		    printCLIError("Wan Group Does not exist.")
		    return false
        else
		    configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupId"]
        end
	end
	--[[if (db.getRowWhere("Services","ServiceName ='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault = 0") ~=nil and configRow["FirewallRules.TypeOfService"] ~= nil) then
		printCLIError("qos_priority of custom service can't be changed.")
		return false
	end]]--
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" or configRow["FirewallRules.SourceAddressStart"] == "0.0.0.0") then
			printCLIError("Enter dmz_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" or configRow["FirewallRules.SourceAddressEnd"] == "0.0.0.0") then
			    printCLIError("Enter dmz_user_end_ip.")
			    return false
		    end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for dmz Users")
                return false
            end
        end
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
    if ( configRow["FirewallRules.SourceAddressType"] == '0' or configRow["FirewallRules.SourceAddressType"] == '1' ) then
		if (configRow["FirewallRules.SourceAddressEnd"] ~= "" and configRow["FirewallRules.SourceAddressEnd"] ~= nil) then
            printCLIError("dmz_user_end_ip option is not applicable if dmz_users is ANY or SINGLE ADDRESS.")
			return false
		end
        if ( configRow["FirewallRules.SourceAddressType"] == '0') then
            if (configRow["FirewallRules.SourceAddressStart"] ~= "" and configRow["FirewallRules.SourceAddressStart"] ~= nil) then
                printCLIError("dmz_user_start_ip option is not applicable if dmz_users is ANY.")
			    return false
            end
		end
	end
    end
	if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
		if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == "" or configRow["FirewallRules.DestinationAddressStart"] == "0.0.0.0") then
			printCLIError("Enter wan_user_start_ip.")
			return false
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "2")then
		if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
			printCLIError("Invalid wan_user_end_ip. ")
			return false
		end
        local status = ''
        status = ifDev.ipSubnet(configRow["FirewallRules.DestinationAddressStart"],"255.255.0.0",configRow["FirewallRules.DestinationAddressStart"],configRow["FirewallRules.DestinationAddressEnd"])
        if (status == "Error: Start IP can't be greater than End IP") then
            printCLIError (status.." for Wan Users")
            return false
        end
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
    if ( configRow["FirewallRules.DestinationAddressType"] == '0' or configRow["FirewallRules.DestinationAddressType"] == '1' ) then
		if (configRow["FirewallRules.DestinationAddressEnd"] ~= "" and configRow["FirewallRules.DestinationAddressEnd"] ~= nil) then
            printCLIError("wan_user_end_ip option is not applicable if wan_users is ANY or SINGLE ADDRESS.")
			return false
		end
        if ( configRow["FirewallRules.DestinationAddressType"] == '0') then
            if (configRow["FirewallRules.DestinationAddressStart"] ~= "" and configRow["FirewallRules.DestinationAddressStart"] ~= nil) then
                printCLIError("wan_user_start_ip option is not applicable if wan_users is ANY.")
			    return false
            end
		end
	end
    end
	if(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT MODE
        if (configRow["FirewallRules.Action"] == "DROP" and configRow["FirewallRules._ROWID_"] == "-1") then
            if (configRow["FirewallRules.SNATAddressType"] ~= "" and configRow["FirewallRules.SNATAddressType"] ~= nil) then
			    printCLIError("nat option is not applicable if action is ALWAYS_BLOCK.")
			    return false
            end
		end
		if(configRow["FirewallRules.SNATAddressType"] ~= nil) then
            if(configRow["FirewallRules.SNATAddressType"] ~= "7") then
                if(configRow["FirewallRules.SNATAddressType"] ~= "WAN1" and 
                   configRow["FirewallRules.SNATAddressType"] ~= "WAN2" and
                   configRow["FirewallRules.SNATAddressType"] ~= "WAN3" and
                   configRow["FirewallRules.SNATAddressType"] ~= "WAN4") then
                    configRow["FirewallRules.SNATAddress"] = configRow["FirewallRules.SNATAddressType"]
                    configRow["FirewallRules.SNATAddressType"] = "1"
                    local ipAddress = configRow["FirewallRules.SNATAddress"]
                    if (db.existsRowWhere("ifStaticIPAlias","LogicalIfName!='LAN' AND IPAddress='"..ipAddress.."'")) then
                        configRow["FirewallRules.SNATInterface"] = db.getAttribute ("ifStaticIPAlias", "IPAddress", ipAddress, "LogicalIfName")
                    else
                        printCLIError ("Nat IP doesn't exists in any WAN secondary addresses. Please select from following IP Addresses")
                        local natIpTable = db.getRowsWhere("ifStaticIPAlias","LogicalIfName!='LAN'")
                        local i = 0
                        for k,v in pairs(natIpTable) do
                            i = i + 1
                            local natIp = natIpTable[i]
                            if (natIp ~= nil) then
                                print("'"..natIp["ifStaticIPAlias.IPAddress"].."'")
                            end
                        end
                        return false
                    end
                else
                    configRow["FirewallRules.SNATInterface"] = configRow["FirewallRules.SNATAddressType"]
                    configRow["FirewallRules.SNATAddress"] = ''
                    configRow["FirewallRules.SNATAddressType"] = "1"
                end
            end
        end
	else
		--classical routing
        if(configRow["FirewallRules._ROWID_"] == "-1") then
		--if (configRow["FirewallRules.SNATAddress"] ~= "" and configRow["FirewallRules.SNATAddress"] ~= nil) then
			--printCLIError("nat_ip is not applicable in classical routing.")
			--return false
		--end
		if (configRow["FirewallRules.SNATAddressType"] ~= "" and configRow["FirewallRules.SNATAddressType"] ~= nil) then
			printCLIError("nat option is not applicable in classical routing.")
			return false
		end
        end
	end
    --[[if (configRow["FirewallRules.Action"] == "DROP") then
        if (configRow["FirewallRules.TypeOfService"] ~= "" and configRow["FirewallRules.TypeOfService"] ~= nil) then
            printCLIError("qos_priority option is not applicable when action is ALWAYS_BLOCK.")
			return false
		end
    end]]--
    if(configRow["FirewallRules.Action"] ~= "DROP")then
        local QosProfileRow = {}
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil) then
            QosProfileRow = db.getRow ("qosProfile","ProfileName",configRow["FirewallRules.QosProfileName"])
        end
        if (configRow["FirewallRules.QosProfileName"] == "" or configRow["FirewallRules.QosProfileName"] == nil or
           (configRow["FirewallRules.QosProfileName"] ~= "None" and QosProfileRow == nil)) then
            printCLIError("Invalid qos_profile name.Please select from following QoS Profiles")
            print("'None'")
            local qosTable = db.getTable("qosProfile")
            local i = 0
            for k,v in pairs(qosTable) do
                i = i + 1
                local qos = qosTable[i]
                if (qos ~= nil) then
                    print("'"..qos["qosProfile.ProfileName"].."'")
                end
            end
            return false
        end
        if (configRow["FirewallRules.QosProfileName"] == "None") then
            configRow["FirewallRules.QosProfileName"] = "0"
        end
    else
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil and
            configRow["FirewallRules.QosProfileName"] ~= "None" and configRow["FirewallRules._ROWID_"] == "-1") then
            printCLIError ("Qos Profile is not applicable when Action is ALWAYS_BLOCK")
            return false
        end
    end
    if(configRow["FirewallRules.RuleType"] == "PUBLIC_INSECURE" and configRow["FirewallRules.ServiceName"] == "ANY" and	configRow["FirewallRules.SourceAddressType"] == "0" and configRow["FirewallRules.DestinationAddressType"] == "0" and configRow["FirewallRules.Action"] == "DROP" and	configRow["FirewallRules.LogLevel"] == "1" and configRow["FirewallRules.SNATInterface"] == "WAN1" and configRow["FirewallRules.QosProfileName"] == "None") then
 configRow["FirewallRules.DscpMark"] = "Default"
    
    if (db.existsRowWhere("FirewallRules", "RuleType='PUBLIC_INSECURE' AND DscpMark ='Default'")) then
       printCLIError("This rule already exists!")
        return false
    end
    end
	return true
end

--wan-dmz config function
function accessControlWDRuleCfgInit(args)
	local configRow={}
    	local rowId = args[1]
    	if (rowId == nil) then
		--initialization for add case
   		configRow["FirewallRules.Status"] = "1"
		configRow["FirewallRules.RuleType"] = "INSECURE_PUBLIC"
		configRow["FirewallRules.FromZoneType"] = "INSECURE"
		configRow["FirewallRules.ToZoneType"] = "PUBLIC"
		configRow["FirewallRules.ServiceName"] = "ANY"
		configRow["FirewallRules.SourceAddressType"] = "0" --Any
		configRow["FirewallRules.Action"] = "DROP" --Block Always
		configRow["FirewallRules.LogLevel"] = "1" --Never
		configRow["FirewallRules._ROWID_"] = "-1"
        configRow["FirewallRules.QosProfileName"] = "None"
        --added
        configRow["FirewallRules.DscpMark"] = "Custom"
		--initialization according to WAN mode(NAT or Classical Routing.)
		local wanMode = db.getAttribute("NatTable","rowid","1","Enable") or '1'	
		if(wanMode == "1")then --nat
			configRow["FirewallRules.DestinationPublicInterface"] = "WAN1" --Broadband
		elseif(wanMode == "0")then --classical routing
			configRow["FirewallRules.DestinationAddressType"] = "0" --Any	
			configRow["FirewallRules.DNATPortEnable"] = "0" --DNAT Port Disabled
		end
        else
		--initialization for edit case
        	configRow= db.getRow("FirewallRules","_ROWID_",rowId)
	        if (configRow == nil) then
          		print("Row does not exist")          
           		return -1
        	end
        if(configRow["FirewallRules.QosProfileName"] == "0") then
            configRow["FirewallRules.QosProfileName"] = "None"
        end
        if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
        configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
            local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.SourceAddressType"] .. " AND ipGroupType=1")
            if (ipGroupId ~= nil) then
		        configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupName"]
            end
	    end
		if(configRow["FirewallRules.RuleType"] ~= "INSECURE_PUBLIC")then 
			printCLIError("Rule is not dmz-wan inbound rule. Edit will not be effective.")
			return -1
		end
		return rowId,configRow
    	end	
    	return -1,configRow
end


function accessControlWDRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    if (configRow["FirewallRules._ROWID_"] == "-1") then
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()    
    end
    return errorFlag, statusMessage
end


function accessControlWDRuleCfgInputVal(configRow)
	if (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil  and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
	if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end
	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end
    else
		if (configRow["FirewallRules.ScheduleName"] ~= nil and configRow["FirewallRules.ScheduleName"] ~= "" and
            configRow["FirewallRules._ROWID_"] == "-1")then
			printCLIError("schedule name option is not applicable if Action field is ALWAYS_ALLOW or ALWAYS_BLOCK.")
			return false
		end
	end
    if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
       configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
        local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.SourceAddressType"] .. "' AND ipGroupType=1")
        if (ipGroupId == nil) then
		    printCLIError("Wan Group Does not exist.")
		    return false
        else
		    configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupId"]
        end
	end
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == ""or configRow["FirewallRules.SourceAddressStart"] == "0.0.0.0" ) then
			printCLIError("Enter wan_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == ""or configRow["FirewallRules.SourceAddressEnd"] == "0.0.0.0" ) then
			    printCLIError("Enter wan_user_end_ip.")
			    return false
		    end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for Wan Users")
                return false
            end
        end
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
    if ( configRow["FirewallRules.SourceAddressType"] == '0' or configRow["FirewallRules.SourceAddressType"] == '1' ) then
		if (configRow["FirewallRules.SourceAddressEnd"] ~= "" and configRow["FirewallRules.SourceAddressEnd"] ~= nil) then
            printCLIError("wan_user_end_ip option is not applicable if wan_users is ANY or SINGLE ADDRESS.")
			return false
		end
        if ( configRow["FirewallRules.SourceAddressType"] == '0') then
            if (configRow["FirewallRules.SourceAddressStart"] ~= "" and configRow["FirewallRules.SourceAddressStart"] ~= nil) then
                printCLIError("wan_user_start_ip option is not applicable if wan_users is ANY.")
			    return false
            end
		end
	end
    if (configRow["FirewallRules.DNATPortEnable"] == "0") then
        if (configRow["FirewallRules.DNATPort"] ~= "" and configRow["FirewallRules.DNATPort"] ~= nil) then
            printCLIError("dnat_port option is not applicable translate_to_port_number is not enable.")
			return false
        end
    end
    end
	--if classical routing
	if(db.getAttribute("NatTable","rowid","1","Enable") == "0")then
		if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
			if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == "" or configRow["FirewallRules.DestinationAddressStart"] == "0.0.0.0") then
				printCLIError("Enter dmz_user_start_ip.")
				return false
			end
		end
		if (configRow["FirewallRules.DestinationAddressType"] == "2")then
			if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
				printCLIError("Invalid dmz_user_end_ip.")
				return false
			end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.DestinationAddressStart"],"255.255.0.0",configRow["FirewallRules.DestinationAddressStart"],configRow["FirewallRules.DestinationAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for dmz Users")
                return false
            end
		end
        if(configRow["FirewallRules._ROWID_"] == "-1") then
        if ( configRow["FirewallRules.DestinationAddressType"] == '0' or configRow["FirewallRules.DestinationAddressType"] == '1' ) then
		    if (configRow["FirewallRules.DestinationAddressEnd"] ~= "" and configRow["FirewallRules.DestinationAddressEnd"] ~= nil) then
                printCLIError("dmz_user_end_ip option is not applicable if dmz_users is ANY or SINGLE ADDRESS.")
			    return false
		    end
            if ( configRow["FirewallRules.DestinationAddressType"] == '0') then
                if (configRow["FirewallRules.DestinationAddressStart"] ~= "" and configRow["FirewallRules.DestinationAddressStart"] ~= nil) then
                    printCLIError("dmz_user_start_ip option is not applicable if dmz_users is ANY.")
			        return false
                end
		    end
	    end
		--unnecessary inputs
		if(configRow["FirewallRules.DNATAddress"] ~= nil and configRow["FirewallRules.DNATAddress"] ~= "")then 
			printCLIError("send_to_dmz_server_ip is not applicable in classical routing mode.")
			return false
		end
		if(configRow["FirewallRules.DestinationPublicAddress"] ~= nil and configRow["FirewallRules.DestinationPublicAddress"] ~= "")then 
			printCLIError("wan_destination_ip_address_start is not applicable in classical routing mode.")
			return false
		end
        if(configRow["FirewallRules.DestinationPublicInterface"] ~= nil and configRow["FirewallRules.DestinationPublicInterface"] ~= "")then 
			printCLIError("wan_destination_ip_address is not applicable in classical routing mode.")
			return false
		end
        end
	elseif(db.getAttribute("NatTable","rowid","1","Enable") == "1")then --NAT
		if (configRow["FirewallRules.DNATPortEnable"] == "1" and (configRow["FirewallRules.DNATPort"] == nil or configRow["FirewallRules.DNATPort"] == "")) then
			printCLIError("Enter the dnat_port.")
			return false
		end
		if ( configRow["FirewallRules.DestinationPublicInterface"] == "OTHER" and ( configRow["FirewallRules.DestinationPublicAddress"] == nil or configRow["FirewallRules.DestinationPublicAddress"] == "" or configRow["FirewallRules.DestinationPublicAddress"] == "0.0.0.0")) then
			printCLIError("Enter the wan_destination_ip_address_start.")
			return false
		elseif ( configRow["FirewallRules.DestinationPublicInterface"] == "RANGE" ) then
			printCLIError("IN case of DMZ Inbound case wan_destination_ip_address = RANGE is INVALID.")
			return false
        elseif ( configRow["FirewallRules.DestinationPublicAddress"] ~= nil and configRow["FirewallRules.DestinationPublicAddress"] ~= "" and
            configRow["FirewallRules._ROWID_"] == "-1") then
			printCLIError("wan_destination_ip_address_start is not applicable if wan_destination_ip_address is WAN")
			return false
		end
		if(configRow["FirewallRules.Action"] ~="DROP")then
			if(configRow["FirewallRules.DNATAddress"] == "" or configRow["FirewallRules.DNATAddress"] == nil)then
				printCLIError("Please enter send_to_dmz_server_ip.")
				return false
			end
		end
        if(configRow["FirewallRules._ROWID_"] == "-1") then
		if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "")then 
			printCLIError("dmz_user is not applicable in nat routing mode.")
			return false
		end
        if(configRow["FirewallRules.DestinationAddressStart"] ~= nil and configRow["FirewallRules.DestinationAddressStart"] ~= "")then 
			printCLIError("dmz_user_start_ip is not applicable in nat routing mode.")
			return false
		end
        if(configRow["FirewallRules.DestinationAddressEnd"] ~= nil and configRow["FirewallRules.DestinationAddressEnd"] ~= "")then 
			printCLIError("dmz_user_end_ip is not applicable in nat routing mode.")
			return false
		end
        end

	end
    if(configRow["FirewallRules.Action"] ~= "DROP")then
        local QosProfileRow = {}
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil) then
            QosProfileRow = db.getRow ("qosProfile","ProfileName",configRow["FirewallRules.QosProfileName"])
        end
        if (configRow["FirewallRules.QosProfileName"] == "" or configRow["FirewallRules.QosProfileName"] == nil or
           (configRow["FirewallRules.QosProfileName"] ~= "None" and QosProfileRow == nil)) then
            printCLIError("Invalid qos_profile name.Please select from following QoS Profiles")
            print("'None'")
            local qosTable = db.getTable("qosProfile")
            local i = 0
            for k,v in pairs(qosTable) do
                i = i + 1
                local qos = qosTable[i]
                if (qos ~= nil) then
                    print("'"..qos["qosProfile.ProfileName"].."'")
                end
            end
            return false
        end
        if (configRow["FirewallRules.QosProfileName"] == "None") then
            configRow["FirewallRules.QosProfileName"] = "0"
        end
    else
        if (configRow["FirewallRules.QosProfileName"] ~= "" and configRow["FirewallRules.QosProfileName"] ~= nil and
            configRow["FirewallRules.QosProfileName"] ~= "None" and configRow["FirewallRules._ROWID_"] == "-1") then
            printCLIError ("Qos Profile is not applicable when Action is ALWAYS_BLOCK")
            return false
        end
    end
    if (configRow["FirewallRules.RuleType"] == "INSECURE_PUBLIC" and configRow["FirewallRules.ServiceName"] == "ANY" and configRow["FirewallRules.SourceAddressType"] == "0" and configRow["FirewallRules.Action"] == "DROP" and configRow["FirewallRules.LogLevel"] == "1" and configRow["FirewallRules.QosProfileName"] == "None" and configRow["FirewallRules.DestinationPublicInterface"] == "WAN1") then
configRow["FirewallRules.DscpMark"] = "Default"
    
    if (db.existsRowWhere("FirewallRules", "RuleType='INSECURE_PUBLIC' AND DscpMark ='Default'")) then
       printCLIError("This rule already exists!")
        return false
    end
    end
	return true
end

--lan-dmz config function
function accessControlLDRuleCfgInit(args)
	local configRow={}
		--initialization of default values
	local rowId = args[1]
    	if (rowId == nil) then
		--initialization for add case	
	       	configRow["FirewallRules.Status"] = "1"
		configRow["FirewallRules.RuleType"] = "SECURE_PUBLIC"
		configRow["FirewallRules.FromZoneType"] = "SECURE"
		configRow["FirewallRules.ToZoneType"] = "PUBLIC"
		configRow["FirewallRules.ServiceName"] = "ANY"
		configRow["FirewallRules.SourceAddressType"] = "0" --Any
		configRow["FirewallRules.DestinationAddressType"] = "0" --Any
		configRow["FirewallRules.Action"] = "DROP" --Block Always
		configRow["FirewallRules.LogLevel"] = "1" --Never
		configRow["FirewallRules._ROWID_"] = "-1"
        --added
        configRow["FirewallRules.DscpMark"] = "Custom"
	else
		--initialization for edit case
        	configRow= db.getRow("FirewallRules","_ROWID_",rowId)
	        if (configRow == nil) then
          		print("Row does not exist")          
           		return -1
        	end
        if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
        configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
            local id = tonumber(configRow["FirewallRules.SourceAddressType"]) - 2
		    local LanGroupName = db.getAttribute("LanGroup","rowid",id,"GroupName")
		    if( LanGroupName == nil )then
                local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.SourceAddressType"] .. " AND ipGroupType=0")
                if (ipGroupId ~= nil) then
			        configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupName"]
                end
		    else
			    configRow["FirewallRules.SourceAddressType"] = LanGroupName
		    end
	    end
		if(configRow["FirewallRules.RuleType"] ~= "SECURE_PUBLIC")then 
			printCLIError("Rule is not lan-dmz outbound rule. Edit will not be effective.")
           		return -1
		end
		return rowId,configRow
	end
    	return -1,configRow
end


function accessControlLDRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    if (configRow["FirewallRules._ROWID_"] == "-1") then
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()
    end
    return errorFlag, statusMessage	
end


function accessControlLDRuleCfgInputVal(configRow)
	if (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil  and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
	if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end

	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end	
	end
	if(configRow["FirewallRules.SourceAddressType"] ~= nil and configRow["FirewallRules.SourceAddressType"] ~= "0" and
       configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
		local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.SourceAddressType"],"rowid")
		if( LanGroupRowId == nil )then
			local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.SourceAddressType"] .. "' AND ipGroupType=0")
            if (ipGroupId == nil) then
			    printCLIError("Lan Group Does not exist.")
			    return false
            else
			    configRow["FirewallRules.SourceAddressType"] = ipGroupId["ipGroup.ipGroupId"]
            end
		else
			configRow["FirewallRules.SourceAddressType"] = tonumber(LanGroupRowId) +2
		end
	end
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" or configRow["FirewallRules.SourceAddressStart"] == "0.0.0.0" ) then
			printCLIError("Enter lan_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" or configRow["FirewallRules.SourceAddressEnd"] == "0.0.0.0" ) then
			    printCLIError("Enter lan_user_end_ip.")
			    return false
		    end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for Lan Users")
                return false
            end
        end
	end

	if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
		if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == "" or configRow["FirewallRules.DestinationAddressStart"] == "0.0.0.0") then
			printCLIError("Enter dmz_user_start_ip.")
			return false
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "2")then
		if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
			printCLIError("Enter dmz_user_end_ip.")
			return false
		end
        local status = ''
        status = ifDev.ipSubnet(configRow["FirewallRules.DestinationAddressStart"],"255.255.0.0",configRow["FirewallRules.DestinationAddressStart"],configRow["FirewallRules.DestinationAddressEnd"])
        if (status == "Error: Start IP can't be greater than End IP") then
            printCLIError (status.." for dmz Users")
            return false
        end
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
	if(configRow["FirewallRules.ScheduleName"] ~= nil and configRow["FirewallRules.ScheduleName"] ~= "")then
	    if(configRow["FirewallRules.Action"] ~= "DROP_BY_SCHEDULE" and configRow["FirewallRules.Action"] ~= "ACCEPT_BY_SCHEDULE")then
		printCLIError("Schedule is not applicable.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressStart"] ~= nil and configRow["FirewallRules.SourceAddressStart"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("lan_user_start_ip is applicable only when lan_users  is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressEnd"] ~= nil and configRow["FirewallRules.SourceAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("lan_user_end_ip is applicable only when lan_users  is  ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressStart"] ~= nil and configRow["FirewallRules.DestinationAddressStart"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("dmz_user_start_ip is applicable only when dmz_users  is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressEnd"] ~= nil and configRow["FirewallRules.DestinationAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("dmz_user_end_ip is applicable only when dmz_users is ADDRESS_RANGE.")
		return false
	    end
	end
    end
    if (configRow["FirewallRules.RuleType"] == "SECURE_PUBLIC" and	configRow["FirewallRules.ServiceName"] == "ANY" and	configRow["FirewallRules.SourceAddressType"] == "0" and	configRow["FirewallRules.DestinationAddressType"] == "0" and configRow["FirewallRules.Action"] == "DROP" and	configRow["FirewallRules.LogLevel"] == "1" ) then
    configRow["FirewallRules.DscpMark"] = "Default"
    
    if (db.existsRowWhere("FirewallRules", "RuleType='SECURE_PUBLIC' AND DscpMark ='Default'")) then
       printCLIError("This rule already exists!")
        return false
    end
    end

	return true
end

--dmz-lan config function
function accessControlDLRuleCfgInit(args)
	local configRow={}
		--initialization of default values
	local rowId = args[1]
    	if (rowId == nil) then
		--initialization for add case
	       	configRow["FirewallRules.Status"] = "1"
		configRow["FirewallRules.RuleType"] = "PUBLIC_SECURE"
		configRow["FirewallRules.FromZoneType"] = "PUBLIC"
		configRow["FirewallRules.ToZoneType"] = "SECURE"
		configRow["FirewallRules.ServiceName"] = "ANY"
		configRow["FirewallRules.SourceAddressType"] = "0" --Any
		configRow["FirewallRules.DestinationAddressType"] = "0" --Any
		configRow["FirewallRules.Action"] = "DROP" --Block Always
		configRow["FirewallRules.LogLevel"] = "1" --Never
		configRow["FirewallRules._ROWID_"] = "-1"
        --added
        configRow["FirewallRules.DscpMark"] = "Custom"
	else
		--initialization for edit case
        	configRow= db.getRow("FirewallRules","_ROWID_",rowId)
	        if (configRow == nil) then
          		print("Row does not exist")          
           		return -1
        	end
        if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
            local id = tonumber(configRow["FirewallRules.DestinationAddressType"]) - 2
		    local LanGroupName = db.getAttribute("LanGroup","rowid",id,"GroupName")
		    if( LanGroupName == nil )then
                local ipGroupId = db.getRowWhere ("ipGroup","ipGroupId=" .. configRow["FirewallRules.DestinationAddressType"] .. " AND ipGroupType=0")
                if (ipGroupId ~= nil) then
			        configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupName"]
                end
		    else
			    configRow["FirewallRules.DestinationAddressType"] = LanGroupName
		    end
	    end
		if(configRow["FirewallRules.RuleType"] ~= "PUBLIC_SECURE")then 
			printCLIError("Rule is not lan-dmz inbound rule. Edit will not be effective.")
			return -1
		end
		return rowId,configRow
	end
    	return -1,configRow
end


function accessControlDLRuleCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FirewallRules"
    if (configRow["FirewallRules._ROWID_"] == "-1") then
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, "-1", "add")
    else
        errorFlag, statusMessage = fwView.firewallRulesConfig(configRow, configRow["FirewallRules._ROWID_"], "edit")
    end
    if (errorFlag == "OK") then
        db.save()
	DeleteStaleInput()
    end
    return errorFlag, statusMessage	
end


function accessControlDLRuleCfgInputVal(configRow)
	if (db.getAttribute("Services","ServiceName",configRow["FirewallRules.ServiceName"],"ServiceName") == nil  and db.getAttribute("serviceGroup","serviceGroupName",configRow["FirewallRules.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
	if (db.existsRowWhere("Services","ServiceName='"..configRow["FirewallRules.ServiceName"].."' AND IsDefault=0 AND Protocol=58")) then
		printCLIError("IPv6 custom services can not be used in IPv4 Firewall Rules.")
		return false
	end

	if (configRow["FirewallRules.Action"] == "DROP_BY_SCHEDULE" or configRow["FirewallRules.Action"] == "ACCEPT_BY_SCHEDULE")then
		if (configRow["FirewallRules.ScheduleName"] == nil or configRow["FirewallRules.ScheduleName"] == "")then
			printCLIError("Please Select schedule.")
			return false
		end	
	end
	if(configRow["FirewallRules.DestinationAddressType"] ~= nil and configRow["FirewallRules.DestinationAddressType"] ~= "0" and
        configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		local LanGroupRowId = db.getAttribute("LanGroup","GroupName",configRow["FirewallRules.DestinationAddressType"],"rowid")
		if( LanGroupRowId == nil )then
			local ipGroupId = db.getRowWhere ("ipGroup","ipGroupName='" .. configRow["FirewallRules.DestinationAddressType"] .. "' AND ipGroupType=0")
            if (ipGroupId == nil) then
			    printCLIError("Lan Group Does not exist.")
			    return false
            else
			    configRow["FirewallRules.DestinationAddressType"] = ipGroupId["ipGroup.ipGroupId"]
            end
		else
			configRow["FirewallRules.DestinationAddressType"] = tonumber(LanGroupRowId) +2
		end
	end
	if ( configRow["FirewallRules.SourceAddressType"] == '1' or configRow["FirewallRules.SourceAddressType"] == '2' ) then
		if ( configRow["FirewallRules.SourceAddressStart"] == nil or  configRow["FirewallRules.SourceAddressStart"] == "" ) then
			printCLIError("Enter dmz_user_start_ip.")
			return false
		end
		if ( configRow["FirewallRules.SourceAddressType"] == '2') then
            if (configRow["FirewallRules.SourceAddressEnd"] == nil or  configRow["FirewallRules.SourceAddressEnd"] == "" ) then
			    printCLIError("Enter dmz_user_end_ip.")
			    return false
		    end
            local status = ''
            status = ifDev.ipSubnet(configRow["FirewallRules.SourceAddressStart"],"255.255.0.0",configRow["FirewallRules.SourceAddressStart"],configRow["FirewallRules.SourceAddressEnd"])
            if (status == "Error: Start IP can't be greater than End IP") then
                printCLIError (status.." for dmz Users")
                return false
            end
        end
	end

	if (configRow["FirewallRules.DestinationAddressType"] == "1" or configRow["FirewallRules.DestinationAddressType"] == "2" )then
		if ( configRow["FirewallRules.DestinationAddressStart"] == nil or  configRow["FirewallRules.DestinationAddressStart"] == "" ) then
			printCLIError("Enter lan_user_start_ip.")
			return false
		end
	end
	if (configRow["FirewallRules.DestinationAddressType"] == "2")then
		if (configRow["FirewallRules.DestinationAddressEnd"] == nil or configRow["FirewallRules.DestinationAddressEnd"] == "" or configRow["FirewallRules.DestinationAddressEnd"] == "0.0.0.0")then
			printCLIError("Invalid lan_user_end_ip.")
			return false
		end
        local status = ''
        status = ifDev.ipSubnet(configRow["FirewallRules.DestinationAddressStart"],"255.255.0.0",configRow["FirewallRules.DestinationAddressStart"],configRow["FirewallRules.DestinationAddressEnd"])
        if (status == "Error: Start IP can't be greater than End IP") then
            printCLIError (status.." for Lan Users")
            return false
        end
	end
    if(configRow["FirewallRules._ROWID_"] == "-1") then
	if(configRow["FirewallRules.ScheduleName"] ~= nil and configRow["FirewallRules.ScheduleName"] ~= "")then
	    if(configRow["FirewallRules.Action"] ~= "DROP_BY_SCHEDULE" and configRow["FirewallRules.Action"] ~= "ACCEPT_BY_SCHEDULE")then
		printCLIError("Schedule is not applicable.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressStart"] ~= nil and configRow["FirewallRules.SourceAddressStart"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "1" and configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("dmz_user_start_ip is applicable only when dmz_users  is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.SourceAddressEnd"] ~= nil and configRow["FirewallRules.SourceAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.SourceAddressType"] ~= "2")then
		printCLIError("dmz_user_end_ip is applicable only when dmz_users  is  ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressStart"] ~= nil and configRow["FirewallRules.DestinationAddressStart"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "1" and configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("lan_user_start_ip is applicable only when lan_users  is SINGLE_ADDRESS or ADDRESS_RANGE.")
		return false
	    end
	end
	if(configRow["FirewallRules.DestinationAddressEnd"] ~= nil and configRow["FirewallRules.DestinationAddressEnd"] ~= "")then
	    if(configRow["FirewallRules.DestinationAddressType"] ~= "2")then
		printCLIError("lan_user_end_ip is applicable only when lan_users  is  ADDRESS_RANGE.")
		return false
	    end
	end
    end
    if (configRow["FirewallRules.RuleType"] == "PUBLIC_SECURE" and	configRow["FirewallRules.ServiceName"] == "ANY" and	configRow["FirewallRules.SourceAddressType"] == "0" and configRow["FirewallRules.DestinationAddressType"] == "0" and configRow["FirewallRules.Action"] == "DROP" and configRow["FirewallRules.LogLevel"] == "1" ) then
        configRow["FirewallRules.DscpMark"] = "Default"
    
    if (db.existsRowWhere("FirewallRules", "RuleType='PUBLIC_SECURE' AND DscpMark ='Default'")) then
       printCLIError("This rule already exists!")
        return false
    end
    end

	return true
end

--}
function FirewalALGsInit(args)
	configRow = db.getRow("SipStatusCtrl", "_ROWID_","1")
	if (configRow == nil) then
		configRow = {}
	end
	return -1,configRow
end

--
--
function FirewalALGsSave(configRow)
local errorFlag="ERROR"
local statusCode=""
local statusMessage=""
DBTable="SipStatusCtrl"
	if(configRow ~= {})then
        local confirm = ''
		if (db.getAttribute("SipStatusCtrl","_ROWID_","1","SipStatus") ~= configRow["SipStatusCtrl.SipStatus"]) then 
    			while (confirm ~= "Y" and confirm ~= "N" and confirm ~= "y" and confirm ~= "n")do
			    printCLIError ("Changing the ALG status requires router reboot. Are you sure you want to proceed [Y/N]? ")
                printCLIError(" WARNING: ALG status will be updated after reboot.")
			    confirm = io.stdin:read'*l'
	        	end
	        	if (confirm == "N" or confirm == "n" ) then
		            errorFlag = "ERROR"
        		    statusMessage = "Action Cancelled"
		            return errorFlag, statusMessage
        		elseif(confirm == "Y" or confirm == "y") then

				    errorFlag, statusCode = sip.config(configRow,"1", "edit")
				    -- save db if no error
				    if (errorFlag == "OK") then db.save() end
                    utilCLIReboot()
    		    end

		end
	end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
	return errorFlag,statusMessage

end

--
--
function FirewalALGsInputVal(configRow)
end

--
--
function FirewalALGsGet(args)
local resultTab={}
      local configRow=db.getRow("SipStatusCtrl","_ROWID_","1")
      printLabel("ALG")
      if (configRow ~= nil)then
	_=[[	if (configRow["AlgConf.Pptp"] == "1")then
			resTab.insertField (resultTab,"PPTP","Enabled")
		else
			resTab.insertField (resultTab,"PPTP","Disabled")
		end
		if (configRow["AlgConf.Ipsec"] == "1")then
			resTab.insertField (resultTab,"Ipsec","Enabled")
		else
			resTab.insertField (resultTab,"Ipsec","Disabled")
		end
		if (configRow["AlgConf.Rtsp"] == "1")then
			resTab.insertField (resultTab,"Rtsp","Enabled")
		else
			resTab.insertField (resultTab,"Rtsp","Disabled")
		end
	]]_=nil
	if (configRow["SipStatusCtrl.SipStatus"] == "1")then
			resTab.insertField (resultTab,"Sip","Enabled")
		else
			resTab.insertField (resultTab,"Sip","Disabled")
		end

	_=[[	if (configRow["AlgConf.H323"] == "1")then
			resTab.insertField (resultTab,"H323","Enabled")
		else
			resTab.insertField (resultTab,"H323","Disabled")
		end

		if (configRow["AlgConf.Smtp"] == "1")then
			resTab.insertField (resultTab,"Smtp","Enabled")
		else
			resTab.insertField (resultTab,"Smtp","Disabled")
		end

		if (configRow["AlgConf.Dns"] == "1")then
			resTab.insertField (resultTab,"Dns","Enabled")
		else
			resTab.insertField (resultTab,"Dns","Disabled")
		end

		if (configRow["AlgConf.Tftp"] == "1")then
			resTab.insertField (resultTab,"Tftp","Enabled")
		else
			resTab.insertField (resultTab,"Tftp","Disabled")
		end
	]]_=nil
resTab.print (resultTab, 0)
      end
end

-- this routine reads in a current access control rule configuration into a 
-- configuration object. Or wii just initialize the defaults in case a new
-- rule is getting added.
function firewallSettings4CfgInit(args)
    local action = args[1]
    local configRow={}
    
    configRow["FirewallRules.Action"] = db.getAttribute("FirewallRules", "RuleType", "DEFAULT_POLICY", "Action")
    if(action == "1") then
      configRow["FirewallRules.Action"] = "ACCEPT"
    else
      configRow["FirewallRules.Action"] = "DROP"
    end
    return configRow["FirewallRules._ROWID_"], configRow
end

-- The routine saves the modified/ newly added access control rule
function firewallSettings4CfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
	
    local rowid = db.getAttribute("FirewallRules", "RuleType", "DEFAULT_POLICY", "_ROWID_")
    if (rowid ~= nil) then
    DBTable = "FirewallRules"
    errorFlag, statusCode = fwView.defaultPolicyConfig(configRow, rowid, "edit") 
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    else
    errorFlag = "ERROR"
    statusMessage = "Default outbound rule not found for IPv4 Firewall Rules."
    end
	
    -- save db if no error
    if (errorFlag == "OK") then db.save() end    
    return errorFlag, statusMessage
end  

