--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: firewall.lua
#### Description: firewall functions

#### Revisions:
#### Venu Babu Munagala
#### Oct 21, 2010
#### added new function rgTelnetAccessMgmt.config()
#### for remote_mgmt.htm 
#### 09apr12,su changes for spr 31017.
#### 
]]--


--************* Requires *************
--require "teamf1lualib/httpsMgmt"
--************* Initial Code *************

--package firewall 
--firewall = {}
telnetAccessMgmt = {}
fwAccessMgmt = {}
rgTelnetAccessMgmt = {}

--table packages
blockSites = {}
remoteMgmt = {}
--************* Functions *************

-- userdb config
function blockSites.blockSites_config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    db.beginTransaction() --begin transaction
    local valid = false
    
    -- config users
    rowid = db.getAttribute("blockSites", "keyword", 
                            inputTable["blockSites.keyword"], "_ROWID_")
    valid = blockSites.config(inputTable, rowid, operation)
    
    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "USERDB_CONFIG_FAILED"

    end
end

-- radius config
function blockSites.config (inputTable, rowid, operation)
    -- validate
        if (operation == "add") then
            return db.insert("blockSites", inputTable)
        elseif (operation == "edit") then
            return db.update("blockSites", inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete("blockSites", inputTable)
        end
    return false
end

-- radius config
function remoteMgmt.config (inputTable, rowid, operation)
    local valid = false
    -- validate
    if (operation == "add") then
        valid = db.insert("accessMgmt", inputTable)
    elseif (operation == "edit") then
        valid = db.update("accessMgmt", inputTable, rowid)
    elseif (operation == "delete") then
        valide = db.delete("accessMgmt", inputTable)
    end
    -- return
	if (valid) then
	    db.commitTransaction(true)
		return "OK", "Operation Succeeded"
	else
	    db.rollback()
	    return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
    end
end

function telnetAccessMgmt.config (inputTable, rowid, operation)
	
	local accessMgmtTable = {}
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	db.beginTransaction() --begin transaction
--        print (" Crossed DB")
	local valid = false
	-- validate
	if (operation == "add") then
		return nil
	elseif (operation == "edit") then
--        print (" Came to Edit operation")
		accessMgmtTable["accessMgmt.accessMgmtEnable"]=inputTable["telnet.telnetEnable"]

--        print ("Sathya values" .. accessMgmtTable["accessMgmt.accessMgmtEnable"])
		accessMgmtTable["accessMgmt.serviceType"]="1"
		accessMgmtTable["accessMgmt.accessMgmtIP1"]=inputTable["telnet.telnetIP1"]
		accessMgmtTable["accessMgmt.accessMgmtIP2"]=inputTable["telnet.telnetIP2"]
	        accessMgmtTable["accessMgmt.accessType"]=inputTable["telnet.telnetAccessType"]

                accessMgmtTable["accessMgmt.port"]=inputTable["telnet.telnetPort"]
		valid =  db.update("accessMgmt", accessMgmtTable, "1")
	elseif (operation == "delete") then
		return nil
	end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "Operation Succeeded"
	else
		db.rollback()
		return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
	end

end

-- Function added to configure accessMgmt table
-- httpsMgmt config
function fwAccessMgmt.config (inputTable, rowid, operation)
        -- if not allowed to edit
        if (ACCESS_LEVEL ~= 0) then
            return "ACCESS_DENIED", "Administrator Privileges Are Required"
        end
        --db.beginTransaction() --begin transaction
        local valid = false
        -- validate
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            --inputTable["accessMgmt.serviceType"]="0"
            valid = db.update("accessMgmt", inputTable, inputTable["accessMgmt.serviceType"])
        else
            return nil 
        end

        -- return
        if (valid) then
            --db.commitTransaction(true)
            return "OK", "Operation Succeeded"
        else
            --db.rollback()
            return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
        end
end

-- Function added to configure Remote SNMP Option
function fwAccessMgmt.remoteSNMPConfig (inputTable, rowid, operation)
        -- if not allowed to edit
        if (ACCESS_LEVEL ~= 0) then
            return "ACCESS_DENIED", "Administrator Privileges Are Required"
        end
        db.beginTransaction() --begin transaction
        local valid = false

        -- validate
        if (operation == "add") then
            valid = db.insert("RemoteSnmp", inputTable)
        elseif (operation == "edit") then
            valid = db.update("RemoteSnmp", inputTable, "1")
        else
            return nil
        end

        -- return
        if (valid) then
            db.commitTransaction(true)
            return "OK", "Operation Succeeded"
        else
            db.rollback()
            return "ERROR", "Remote SNMP Configuration Failed"
        end
end



function rgTelnetAccessMgmt.config (inputTable, rowid, operation)
	
	local accessMgmtTable = {}
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	db.beginTransaction() --begin transaction
	local valid = false
	-- validate
	if (operation == "add") then
		return nil
	elseif (operation == "edit") then
	--update httpmgmt row1 
		accessMgmtTable["accessMgmt.accessMgmtEnable"]=inputTable["accessMgmt.accessMgmtEnable"]
		accessMgmtTable["accessMgmt.serviceType"]="0"
		accessMgmtTable["accessMgmt.accessMgmtIP1"]=inputTable["accessMgmt.accessMgmtIP1"]
		accessMgmtTable["accessMgmt.accessMgmtIP2"]=inputTable["accessMgmt.accessMgmtIP2"]
	        accessMgmtTable["accessMgmt.accessType"]=inputTable["accessMgmt.accessType"]

                accessMgmtTable["accessMgmt.port"]=inputTable["accessMgmt.port"]
		valid =  db.update("accessMgmt", accessMgmtTable, "0")
		
		--update teleMgmt row2 
		if(valid) then
		  accessMgmtTable["accessMgmt.accessMgmtEnable"]=inputTable["telnet.telnetEnable"]

		accessMgmtTable["accessMgmt.serviceType"]="1"
		accessMgmtTable["accessMgmt.accessMgmtIP1"]=inputTable["telnet.telnetIP1"]
		accessMgmtTable["accessMgmt.accessMgmtIP2"]=inputTable["telnet.telnetIP2"]
	        accessMgmtTable["accessMgmt.accessType"]=inputTable["telnet.telnetAccessType"]

                accessMgmtTable["accessMgmt.port"]="23"
		valid =  db.update("accessMgmt", accessMgmtTable, "1")
		end
	elseif (operation == "delete") then
		return nil
	end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "Operation Succeeded"
	else
		db.rollback()
		return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
	end

end

function rgTelnetAccessMgmt.configIpv6 (inputTable, rowid, operation)
	
	local accessMgmtTable = {}
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	db.beginTransaction() --begin transaction
	local valid = false
	-- validate
	if (operation == "add") then
		return nil
	elseif (operation == "edit") then
	--update httpmgmt row1 
		
        accessMgmtTable["accessMgmt.accessMgmt6Enable"]=inputTable["accessMgmt.accessMgmt6Enable"]
		accessMgmtTable["accessMgmt.serviceType"]="0"
		
        accessMgmtTable["accessMgmt.accessMgmtIP3"]=inputTable["accessMgmt.accessMgmtIP3"]
		accessMgmtTable["accessMgmt.accessMgmtIP4"]=inputTable["accessMgmt.accessMgmtIP4"]
	   
        accessMgmtTable["accessMgmt.accessType6"]=inputTable["accessMgmt.accessType6"]

                accessMgmtTable["accessMgmt.port"]=inputTable["accessMgmt.port"]
		valid =  db.update("accessMgmt", accessMgmtTable, "0")
		
		--update teleMgmt row2 
		if(valid) then
		 
          accessMgmtTable["accessMgmt.accessMgmt6Enable"]=inputTable["telnet.telnetV6Enable"]

		accessMgmtTable["accessMgmt.serviceType"]="1"
		
        accessMgmtTable["accessMgmt.accessMgmtIP3"]=inputTable["telnet.accessMgmtIP3"]
        accessMgmtTable["accessMgmt.accessMgmtIP4"]=inputTable["telnet.accessMgmtIP4"]

        accessMgmtTable["accessMgmt.accessType6"]=inputTable["telnet.telnetV6AccessType"]

                accessMgmtTable["accessMgmt.port"]="23"
		valid =  db.update("accessMgmt", accessMgmtTable, "1")
		end
	elseif (operation == "delete") then
		return nil
	end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "Operation Succeeded"
	else
		db.rollback()
		return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
	end

end
