--[[
#### Vivek Dutt Sharma.
#### TeamF1
#### www.TeamF1.com
#### November 26, 2009
#### File: firmware.lua
#### Description: Firmware version checks
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package firmConf
firmConf = {}
firmStatusConf={}

--************* Functions *************

-- Firmware config
function firmConf.config (inputTable, rowid, operation)
    -- validate
    local valid = false
    local STATUS_AVAILABLE = 1
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then 
        	local firmStatusTable={}
        	 firmStatusTable["FirmStatus.StatusAvailable"] = STATUS_AVAILABLE        	      	
            valid = db.update("FirmConf", inputTable, rowid) 
            if(valid) then 
	        valid = db.update("FirmStatus",firmStatusTable,rowid)
	        end
	    -- return
    	    if (valid) then
        	db.commitTransaction()
        	return "OK", "STATUS_OK"
            else
        	db.rollback()
        	return "ERROR", "Operation Failed"
            end
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end

function firmStatusConf.config (inputTable, rowid, operation)
    -- validate
    local valid = false
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            valid = db.update("(FirmStatus", inputTable, rowid)
	    -- return
    	    if (valid) then
        	db.commitTransaction()
        	return "OK", "STATUS_OK"
            else
        	db.rollback()
        	return "ERROR", "FIRMSTATUS_CONFIG_FAILED"
            end
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end

--[[
#### File: firmware.lua
#### Description: firmware lua functions
#### Copyright (c) 2010, TeamF1, Inc. */

#### Modification history:
01a,02feb10,rks written
]]--

firmware = {}
require "firmwareLib"

function firmware.upgrade (filename)

    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        NextPage = ""
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    local filename = filename
    local status = firmwareLib.callFirmwareUpgrade(filename)
    

--    if(atoi(status) == 0) then
  --      util.appendDebugOut("Success")
    --    return "0"
    --else
      --  util.appendDebugOut("FAILED")
       -- return "1"
    --end
    --
    return 0

end


function firmware.getVersion(image)

    local firmwareVer = ""
    local image = image
    if (image ~= nil and image ~= "") then
        if(image == "image1") then
            local firmVersion = io.open("/var/firmVersion", "r")
            if(firmVersion) then
                firmwareVer = firmVersion:read("*all") or ''
                firmVersion:close()
            end
        elseif(image == "image2") then
            local firmVersion = io.open("/var/firmSecVersion", "r")
            if(firmVersion) then
                firmwareVer = firmVersion:read("*all") or ''
                firmVersion:close()
            end
        end
    end
    return "OK",firmwareVer
end

function firmware.getStatus(image)

    local firmwareStat = ""
    local image = image
    if (image ~= nil and image ~= "") then
        if(image == "image1") then
            local firmStatus = io.open("/var/firmStatus", "r")
            if(firmStatus) then
                firmwareStat = firmStatus:read("*all") or ''
                firmStatus:close()
            end
        elseif(image == "image2") then
            local firmStatus = io.open("/var/firmSecStatus", "r")
            if(firmStatus) then
                firmwareStat = firmStatus:read("*all") or ''
                firmStatus:close()
            end
        end
    end
    return firmwareStat
end

function firmware.swapFirmwae(image)

    local bootFlag = ""
    local prog = ""
    local image = image
    if (image ~= nil and image ~= "") then
        if(image == "image1") then
        elseif(image == "image2") then
            local file = io.open("/var/bootflag", "r")
            if(file) then
                bootFlag = file:read("*all") or ''
                file:close()
            end
            if (bootFlag == "0") then
                prog = "setmd bootflag 1"
            else
                prog = "setmd bootflag 0"
            end
            os.execute (prog);
        end
    end
    return "OK", "STATUS_OK"
end
