-- networkQoSCLI.lua
-- Nikhil Kumar
-- TeamF1
-- 02/05/12
-- Modification History
-- 02may12,nik  written
-- Required Libraries

require "teamf1lualib/fwView"

function networkQosCfgInit(args)
    local configRow = {}
    configRow = db.getRow("NetworkQos", "_ROWID_", "1")
    return 1, configRow
end

function networkQosCfgInputVal(configRow)
    return true
end

function networkQosCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "NetworkQos"

    if (configRow["NetworkQos.Enable"] == "0") then
        configRow["NetworkQos.qosType"] = nil
    end
    errorFlag, statusCode = fwView.qosProfileStatusConfig(configRow, "1", "edit")
    if (errorFlag == "OK") then
        db.save()
    end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    fwView.hwOffloadUpdate()
    return errorFlag, statusMessage	
end

function networkQosProfileCfgInit(args)
    local configRow={}
	local rowId = args[1]
	if(rowId == nil )then
        configRow["NetworkQosProfile._ROWID_"] = "-1"
        configRow["NetworkQosProfile.InterfaceName"] = "WAN1"
        configRow["NetworkQosProfile.ServiceName"] = "ANY"
        configRow["NetworkQosProfile.QosProfileStatus"] = "1"
    else
        configRow = db.getRow("NetworkQosProfile", "NetworkQosProfile._ROWID_", rowId)
        if (configRow == nil) then
          	print("Row does not exist")          
           	return -1, {}
        end
        if(configRow["NetworkQosProfile.QosType"] == "0") then
	        configRow["NetworkQosProfile.Direction1"] = configRow["NetworkQosProfile.Direction"]
	    else
	        configRow["NetworkQosProfile.Direction2"] = configRow["NetworkQosProfile.Direction"] 
	    end
    end
    return configRow["NetworkQosProfile._ROWID_"], configRow
end

function networkQosProfileCfgInputVal(configRow)
    if (db.getAttribute("Services","ServiceName",configRow["NetworkQosProfile.ServiceName"],"ServiceName") == nil and db.getAttribute("serviceGroup","serviceGroupName",configRow["NetworkQosProfile.ServiceName"],"serviceGroupName") == nil ) then
		printCLIError("Service doesn't exist, please re-input service_name.")
		return false
	end
    if (configRow["NetworkQosProfile.QosType"] == "" or configRow["NetworkQosProfile.QosType"] == nil) then
        printCLIError("Invalid qos_type")
        return false
    end
    if (configRow["NetworkQosProfile.dscpMatch"] == "" or configRow["NetworkQosProfile.dscpMatch"] == nil) then
        printCLIError("Invalid diffserv_qos_match")
        return false
    end
    if (configRow["NetworkQosProfile.dscpRemark"] == "" or configRow["NetworkQosProfile.dscpRemark"] == nil) then
        printCLIError("Invalid diffserv_qos_remark")
        return false
    end
    if (configRow["NetworkQosProfile.QosType"] == "0") then
        if (configRow["NetworkQosProfile.Direction1"] == "" or configRow["NetworkQosProfile.Direction1"] == nil) then
            printCLIError("Invalid direction_for_rate_control")
            return false
        end
        if (configRow["NetworkQosProfile.CongestionPriority"] == "" or configRow["NetworkQosProfile.CongestionPriority"] == nil or
            configRow["NetworkQosProfile.CongestionPriority"] == "0") then
            printCLIError("Invalid congestion_priority")
            return false
        end
        if (configRow["NetworkQosProfile.Hosts"] == "" or configRow["NetworkQosProfile.Hosts"] == nil or
            configRow["NetworkQosProfile.Hosts"] == "0") then
            printCLIError("Invalid hosts type")
            return false
        end
        if (configRow["NetworkQosProfile.Hosts"] == "1" or configRow["NetworkQosProfile.Hosts"] == "2") then
            if (configRow["NetworkQosProfile.StartIp"] == "" or
                configRow["NetworkQosProfile.StartIp"] == nil or
                configRow["NetworkQosProfile.StartIp"] == "0.0.0.0") then
                printCLIError("Invalid hosts_start_ip")
                return false
            end
            if (configRow["NetworkQosProfile.Hosts"] == "2" and (configRow["NetworkQosProfile.EndIp"] == "" or
                configRow["NetworkQosProfile.EndIp"] == nil or configRow["NetworkQosProfile.EndIp"] == "0.0.0.0")) then
                printCLIError("Invalid hosts_end_ip")
                return false
            end
        elseif(configRow["NetworkQosProfile.Hosts"] == "3") then
            if (configRow["NetworkQosProfile.GroupName"] == "" or configRow["NetworkQosProfile.GroupName"] == nil) then
                printCLIError("Invalid hosts_group")
                return false
            end
        end
        if (configRow["NetworkQosProfile.BwAllocation"] == "" or configRow["NetworkQosProfile.BwAllocation"] == nil) then
            printCLIError("Invalid bandwidth_allocation")
            return false
        end
        if (configRow["NetworkQosProfile.Direction1"] == "1" or configRow["NetworkQosProfile.Direction1"] == "3") then
            if (configRow["NetworkQosProfile.MinInBandWidth"] == "" or configRow["NetworkQosProfile.MinInBandWidth"] == nil) then
                printCLIError("Invalid inbound_min_bandwidth")
                return false
            end
            if (configRow["NetworkQosProfile.MaxInBandWidth"] == "" or configRow["NetworkQosProfile.MaxInBandWidth"] == nil) then
                printCLIError("Invalid inbound_max_bandwidth")
                return false
            end
        end
        if (configRow["NetworkQosProfile.Direction1"] == "2" or configRow["NetworkQosProfile.Direction1"] == "3") then
            if (configRow["NetworkQosProfile.MinOutBandWidth"] == "" or configRow["NetworkQosProfile.MinOutBandWidth"] == nil) then
                printCLIError("Invalid outbound_min_bandwidth")
                return false
            end
            if (configRow["NetworkQosProfile.MaxOutBandWidth"] == "" or configRow["NetworkQosProfile.MaxOutBandWidth"] == nil) then
                printCLIError("Invalid outbound_max_bandwidth")
                return false
            end
        end
    elseif (configRow["NetworkQosProfile.QosType"] == "1") then
        if (configRow["NetworkQosProfile.Direction2"] == "" or configRow["NetworkQosProfile.Direction2"] == nil) then
            printCLIError("Invalid direction_for_priority")
            return false
        end
        if (configRow["NetworkQosProfile.Priority"] == "" or configRow["NetworkQosProfile.Priority"] == nil or
            configRow["NetworkQosProfile.Priority"] == "0") then
            printCLIError("Invalid priority")
            return false
        end
    end
    return true
end

function networkQosProfileCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "NetworkQosProfile"

    if(configRow["NetworkQosProfile.QosType"] == "0") then
	    configRow["NetworkQosProfile.Direction"] = configRow["NetworkQosProfile.Direction1"]
        configRow["NetworkQosProfile.Priority"] = "0"
	else
	    configRow["NetworkQosProfile.Direction"] = configRow["NetworkQosProfile.Direction2"] 
        configRow["NetworkQosProfile.CongestionPriority"] = "0"
	end
    if (configRow["NetworkQosProfile._ROWID_"] == "-1") then
        if(configRow["NetworkQosProfile.QosType"] == "1") then
            configRow["NetworkQosProfile.Hosts"] = "0"
            configRow["NetworkQosProfile.StartIp"] = nil
            configRow["NetworkQosProfile.EndIp"] = nil
            configRow["NetworkQosProfile.GroupName"] = nil
            configRow["NetworkQosProfile.BwAllocation"] = nil
            configRow["NetworkQosProfile.MinInBandWidth"] = nil
            configRow["NetworkQosProfile.MaxInBandWidth"] = nil
            configRow["NetworkQosProfile.MinOutBandWidth"] = nil
            configRow["NetworkQosProfile.MaxOutBandWidth"] = nil
        end
	    errorFlag, statusCode = fwView.profileConfig(configRow, "-1", "add")
	else
	    errorFlag, statusCode = fwView.profileConfig(configRow, configRow["NetworkQosProfile._ROWID_"], "edit")
	end
    if (errorFlag == "OK") then
        db.save()
    end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    return errorFlag, statusMessage	
end

function networkQosProfileDel(args)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "NetworkQosProfile"
    
    configRow= db.getRow("NetworkQosProfile","_ROWID_",args[1])
    if (configRow == nil) then
		printCLIError("Row doesn't exist")
		return false
    end
    local rows = {}
    rows["rowid"] = configRow["NetworkQosProfile._ROWID_"]
    errorFlag, statusCode = fwView.deleteQosProfiles(rows)
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    return errorFlag, statusMessage
end

function networkQosProfileEnable(args)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "NetworkQosProfile"
    
    configRow= db.getRow("NetworkQosProfile","_ROWID_",args[1])
    if (configRow == nil) then
		printCLIError("Row doesn't exist")
		return false
    end
    local rows = {}
    rows["rowid"] = configRow["NetworkQosProfile._ROWID_"]
    errorFlag, statusCode = fwView.modifyQosProfile(rows, 'enable')
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    return errorFlag, statusMessage
end

function networkQosProfileDisable(args)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "NetworkQosProfile"
    
    configRow= db.getRow("NetworkQosProfile","_ROWID_",args[1])
    if (configRow == nil) then
		printCLIError("Row doesn't exist")
		return false
    end
    local rows = {}
    rows["rowid"] = configRow["NetworkQosProfile._ROWID_"]
    errorFlag, statusCode = fwView.modifyQosProfile(rows, 'disable')
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    return errorFlag, statusMessage
end

function networkQosCfgGet()
    local qosRow = db.getRow("NetworkQos", "_ROWID_", "1")
    local qosProfileTable = db.getTable ("NetworkQosProfile")
    local resultTab = {} 
    local resultTab1 = {} 
    local configRow = nil
    local rowId = "0"
 
    for col, val in pairs(qosProfileTable) do
        rowId = rowId+1
        local configRow = qosProfileTable[rowId]
	    if (rowId ~= nil) then
            local direction = ''
            local rate = ''
            local host = ''
	        resTab.insertField (resultTab, "ROW ID", configRow["NetworkQosProfile._ROWID_"] or "")
            if (configRow["NetworkQosProfile.QosType"] == "0") then
                resTab.insertField (resultTab, "QoS Type","Rate Control")
                if (configRow["NetworkQosProfile.Direction"] == "1") then
                    direction = "Inbound"
                    rate = configRow["NetworkQosProfile.MinInBandWidth"].." - "..configRow["NetworkQosProfile.MaxInBandWidth"]
                elseif (configRow["NetworkQosProfile.Direction"] == "2") then
                    direction = "Outbound"
                    rate = configRow["NetworkQosProfile.MinOutBandWidth"].." - "..configRow["NetworkQosProfile.MaxOutBandWidth"]
                elseif (configRow["NetworkQosProfile.Direction"] == "3") then
                    direction = "Both"
                    rate = configRow["NetworkQosProfile.MinInBandWidth"].." - " ..configRow["NetworkQosProfile.MaxInBandWidth"].."/"..configRow["NetworkQosProfile.MinOutBandWidth"].." - "..configRow["NetworkQosProfile.MaxOutBandWidth"]
                end

                if (configRow["NetworkQosProfile.Hosts"] == "1") then
                    host = configRow["NetworkQosProfile.StartIp"]
                elseif (configRow["NetworkQosProfile.Hosts"] == "2") then
                    host = configRow["NetworkQosProfile.StartIp"].." - "..configRow["NetworkQosProfile.EndIp"]
                elseif (configRow["NetworkQosProfile.Hosts"] == "3") then
                    host = configRow["NetworkQosProfile.GroupName"]
                end
            else
                resTab.insertField (resultTab, "QoS Type","Priority")
                if (configRow["NetworkQosProfile.Direction"] == "1") then
                    direction = "Inbound Traffic"
                elseif (configRow["NetworkQosProfile.Direction"] == "2") then
                    direction = "Outbound Traffic"
                end
                if (configRow["NetworkQosProfile.Priority"] == "1") then
                    rate = "Low"
                elseif (configRow["NetworkQosProfile.Priority"] == "2") then
                    rate = "High"
                end
                host = "-"
            end
        	resTab.insertField (resultTab, "Interface Name", configRow["NetworkQosProfile.InterfaceName"] or "")
        	resTab.insertField (resultTab, "ServiceName", configRow["NetworkQosProfile.ServiceName"] or "")
        	resTab.insertField (resultTab, "Direction", direction)
        	resTab.insertField (resultTab, "Rate", rate)
        	resTab.insertField (resultTab, "Hosts", host)
        end
    end

    if (qosRow["NetworkQos.Enable"] == "0") then
        resTab.insertField (resultTab1, "Enabled","No")
    else
        resTab.insertField (resultTab1, "Enabled","Yes")
    end
    if (qosRow["NetworkQos.qosType"] == "0") then
        resTab.insertField (resultTab1, "QoS Type","Rate Control")
    else
        resTab.insertField (resultTab1, "QoS Type","Priority")
    end

    printLabel ("Quality of Service")
    resTab.print (resultTab1, 0)
    printLabel ("List of Network QoS Profiles")
    resTab.print (resultTab, 0)
end
