-- websiteFilteringCLI.lua
-- Modification history
-- 29mar12,akr fixed 30860
-- 29mar12,nik fixed SPR 30861
-- Ravindranath
-- TeamF1
-- www.TeamF1.com
-- 02/03/10
--
-- Description
-- CLI interface set and get security website filtering routines

require "teamf1lualib/fwView"
--content filtering
function contentFilteringCfgInit (args)
    configRow = db.getRow("ContentFiltering", "_ROWID_", "1")
    local configRowWeb = db.getRow("WebComponents","_ROWID_", "1")
    configRow = util.tableAppend(configRow, configRowWeb)
    return 1, configRow
end

function contentFilteringCfgSave (configRow)
    errorFlag = "ERROR"
    statusCode = ""
    statusMessage = ""
    DBTable = "ContentFiltering"
    -- update Configuration
    	--local procEntry = db.getAttribute("environment", "name", "HW_OFFLOAD_PROC_ENTRY", "value")
    	--if (configRow["ContentFiltering.Status"] == "1") then
    		--util.appendDebugOut("Exec: " .. os.execute("echo 0 >" .. procEntry))
	--elseif ( configRow["ContentFiltering.Status"] == "0") then
    		--util.appendDebugOut("Exec: " .. os.execute("echo 1 >" .. procEntry))
    	--end
    		errorFlag, statusCode = fwView.contentFileteringConfig(configRow, "1", "edit")
    	
    	-- save db if no error
    	if (errorFlag == "OK") then db.save() end
    	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
        fwView.hwOffloadUpdate()
    return errorFlag, statusMessage
end

function contentFilteringCfgInputVal (configRow)
--	if (configRow["ContentFiltering.Status"] == "0")then
--		printCLIError("Please Enable content filtering first")
--		return false
--	end
    return true
end

function contentFilteringCfgGet (args)
    local row1 = db.getRow ("ContentFiltering", "_ROWID_", "1")
    local row2 = db.getRow ("WebComponents", "_ROWID_", "1")
    if (row1 == nil and row2 == nil) then 
    print ("Content Filtering Configurations Not Available\n")
    else
    printLabel("Content Filtering")
    print ("WAN Security Checks\n")
    if (row1["ContentFiltering.Status"] == "1") then
    print ("Content Filtering : Enabled\n")
    else
    print ("Content Filtering : Disabled\n")
    end
    print ("LAN Security Checks")
    print ("-------------------\n")
    if(row2["WebComponents.ProxyEnable"] == "1") then
    print ("Proxy : Enabled\n")
    else
    print ("Proxy : Disabled\n")
    end
    if(row2["WebComponents.JavaComponentEnable"] == "1") then
    print ("Java : Enabled\n")
    else
    print ("Java : Disabled\n")
    end
    if(row2["WebComponents.ActivexControlEnable"] == "1") then
    print ("ActiveX : Enabled\n")
    else
    print ("ActiveX : Disabled\n")
    end
    if(row2["WebComponents.CookiesEnable"] == "1") then
    print ("Cookies : Enabled\n")
    else
    print ("Cookies : Disabled\n")
    end
    end
end

--trusted domains
function trustedDomainsCfgInit (args)
    -- for Add
    RowId = args[1]
    if (RowId == nil) then
	configRow = db.getDefaults(true, "TrustedDomains")
    -- for edit
    else
	configRow = db.getRow("TrustedDomains", "TrustedDomains._ROWID_",RowId)
    end
    if(configRow == nil)then
       print("Row doesnt exist probably deleted. Please exit from this mode\n")
       return -1, {}
    end
    return 1,configRow
end

function trustedDomainsCfgSave (configRow)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "TrustedDomains"

    RowId = configRow ["TrustedDomains._ROWID_"]
    -- for add
    if (RowId == nil) then
	configRow["TrustedDomains.OID"] = nil 
	errorFlag, statusCode = fwView.trustedDomainConfig(configRow, "-1", "add")
    else
	errorFlag, statusCode = fwView.trustedDomainConfig(configRow, RowId, "edit")
    end

    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function trustedDomainsCfgDel (args)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "TrustedDomains"
    rows = {}
    local configRow={}
    configRow=db.getRow("TrustedDomains","_ROWID_",args[1]) 
    if (configRow == nil)then
		errorFlag="ERROR"
	        statusMessage="Row doesnt exist"
                printCLIError("Row doesnt exist")
		return errorFlag, statusMessage
    else
    rows["rowid"] = configRow["TrustedDomains._ROWID_"]
	if (rows) then
		errorFlag, statusCode = fwView.deleteDomains (rows)
	end
    -- save db if no error
    	if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    end
    return errorFlag, statusMessage
end

function trustedDomainsCfgInputVal (configRow)
    local testRow=db.getRow("ContentFiltering","_ROWID_","1")
    if (testRow["ContentFiltering.Status"] == "0")then
	printCLIError("please Enable content filtering first")
	return false
    end 
    if (configRow["TrustedDomains.KeywordToAllow"] == nil or configRow["TrustedDomains.KeywordToAllow"] == "")then
	printCLIError("please enter a valid url")
	return false
    end
    return true
end

function trustedDomainsCfgGet (args)
    local resultTab = {}
    print("List of available  Approved URLS")
    local i = 0
    local table = db.getTable("TrustedDomains")
    if (table == nil) then
        print ("trusted domains configurations unavailable")
    else
        for k,v in pairs(table) do
        i = i + 1
        local row = table[i]
        if (i ~= nil) then
            resTab.insertField (resultTab, "ROW ID", row["TrustedDomains._ROWID_"] or "")
            resTab.insertField (resultTab, "Domain", row["TrustedDomains.KeywordToAllow"] or "")
        end
        end
    end
    resTab.print (resultTab, 0)
end


--blocked keywords
function blockedKeywordsCfgInit (args)
   -- for Add
    RowId = args[1]
    if (RowId == nil) then
	configRow = db.getDefaults(true, "BlockSites")
    -- for edit
    else
	configRow = db.getRow("BlockSites", "BlockSites._ROWID_",RowId)	
    end
    if(configRow == nil or args[1] == "1")then
       printCLIError("Row doesn't exist.")
       return -1, {}
    end
    return 1,configRow
end

function blockedKeywordsCfgSave (configRow)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "BlockSites"
    RowId = configRow ["BlockSites._ROWID_"]
    -- for add
    if (RowId == nil) then
	configRow["BlockSites.OID"] = nil 
	configRow["BlockSites.KeywordBlockingTo"]="0"
	configRow["BlockSites.Status"]="1"
	errorFlag, statusCode = fwView.blockedKeywordConfig(configRow, "-1", "add")
    else
	errorFlag, statusCode = fwView.blockedKeywordConfig(configRow, RowId, "edit")
    end

    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function blockedKeywordsCfgDel (args)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "BlockSites"
    rows = {}
    local configRow={}
    configRow=db.getRow("BlockSites","_ROWID_",args[1]) 
    if (configRow == nil or args[1] == "1")then
		errorFlag="ERROR"
	        statusMessage="Row doesn't exist"
                printCLIError("Row doesn't exist")
		return errorFlag, statusMessage
    else
    rows["rowid"] = configRow["BlockSites._ROWID_"]
	if (rows) then
		errorFlag, statusCode = fwView.deleteKeywords (rows)
	end
    -- save db if no error
    	if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    end
    return errorFlag, statusMessage

end

function blockedKeywordsCfgInputVal (configRow)
    local testRow=db.getRow("ContentFiltering","_ROWID_","1")
    if (testRow["ContentFiltering.Status"] == "0")then
	printCLIError("please Enable content filtering first")
	return false
    end 
    if (configRow["BlockSites.KeywordToBlock"] == nil or configRow["BlockSites.KeywordToBlock"] == "")then
		printCLIError("Enter valid blocked_keyword")
		return false
    end
    return true
end

function blockedKeywordsStatusModify (args)
    DBTable = "BlockSites"
    rows = {}
    local configRow={}
    configRow=db.getRow("BlockSites","_ROWID_",args[1]) 
    if (configRow == nil)then
		errorFlag="ERROR"
	        statusMessage="Row doesnt exist"
                printCLIError("Row doesnt exist")
		return errorFlag, statusMessage
    else
    rows["rowid"] = args[1]
    	if (rows) then
		errorFlag, statusCode = fwView.modifyKeywordStatus (rows,args[2]) 
    	end
	-- save db if no error
    	if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    end
    return errorFlag, statusMessage
end

function blockedKeywordsCfgGet (args)
    local resultTab = {}

    printLabel ("Blocked Keywords")
    print ("List of available Blocked Keywords\n")
    local i = 0
    local status = ""
    local table = db.getTable ("BlockSites")
    if (table == nil) then
        print ("Blocked Keywords configuration unavailable")
    else
        for k,v in pairs(table) do
        	i = i + 1
	        local row = table[i]
        	if (i ~= nil and row["BlockSites.Status"] == "1") then
	        	resTab.insertField (resultTab, "ROW ID", row["BlockSites._ROWID_"]or "")
        		if(row["BlockSites.Status"] == "1")then
                		status = "Enabled"	
		        elseif (row["BlockSites.Status"] == "0") then
        		        status = "Disabled"
				return false
	        	end
			resTab.insertField (resultTab, "Blocked Keyword ", row["BlockSites.KeywordToBlock"] or "")
			resTab.insertField (resultTab, "Status", status)
	    	end
    	end
   end
   resTab.print (resultTab, 0)
end
function DeleteStaleInput()
	__CLISH_CUR_CONFIG_ROW = {} -- current config info is now discarded
 	__CLISH_EDIT_CONFIG_ROW = {} -- current edit config info is discarded
	return true
end

function blockGroupEnableCfgInit(args)
DBTable = "BlockSites" 
   -- for add
    if (args[1] == nil) then
print(args[1])
      configRow = db.getDefaults(true, "BlockSites")
    configRow["BlockSites._ROWID_"] = "-1"
    -- for edit
 else
       configRow = db.getRow("BlockSites", "BlockSites._ROWID_", 1)
 end
    if(configRow == nil) then
        print("Row(s) doesnot exist\n")
        return -1, {}
    else
	 configRow = fwView.groupConfigGet (configRow)
        rowid = configRow["BlockSites._ROWID_"]
        local val1  = configRow["BlockSites.KeywordBlockingTo"]
    end
rowid=1
    return rowid, configRow
end

function blockGroupDisableCfgInit(args)
DBTable = "BlockSites" 
   -- for add
    if (args[1] == nil) then
print(args[1])
      configRow = db.getDefaults(true, "BlockSites")
    configRow["BlockSites._ROWID_"] = "-1"
    -- for edit
 else
       configRow = db.getRow("BlockSites", "BlockSites._ROWID_", 1)
 end
    if(configRow == nil) then
        print("Row(s) doesnot exist\n")
        return -1, {}
    else
	 configRow = fwView.groupConfigGet (configRow)
        rowid = configRow["BlockSites._ROWID_"]
        local val1  = configRow["BlockSites.KeywordBlockingTo"]
    end
rowid=1
	InitGroup1 = configRow["BlockSites.group1"]
	InitGroup2 = configRow["BlockSites.group2"]
	InitGroup3 = configRow["BlockSites.group3"]
	InitGroup4 = configRow["BlockSites.group4"]
	InitGroup5 = configRow["BlockSites.group5"]
	InitGroup6 = configRow["BlockSites.group6"]
	InitGroup7 = configRow["BlockSites.group7"]
	InitGroup8 = configRow["BlockSites.group8"]
	if (configRow["BlockSites.group1"] == "1" ) then configRow["BlockSites.group1"]="0" end
	if (configRow["BlockSites.group2"] == "1" ) then configRow["BlockSites.group2"]="0" end
	if (configRow["BlockSites.group3"] == "1" ) then configRow["BlockSites.group3"]="0" end
	if (configRow["BlockSites.group4"] == "1" ) then configRow["BlockSites.group4"]="0" end
	if (configRow["BlockSites.group5"] == "1" ) then configRow["BlockSites.group5"]="0" end
	if (configRow["BlockSites.group6"] == "1" ) then configRow["BlockSites.group6"]="0" end
	if (configRow["BlockSites.group7"] == "1" ) then configRow["BlockSites.group7"]="0" end
	if (configRow["BlockSites.group8"] == "1" ) then configRow["BlockSites.group8"]="0" end
	return rowid, configRow
end

function blockGroupEnableCfgInputVal (configRow)
	if(db.getAttribute("ContentFiltering","rowid","1","Status") ~= "1") then
		printCLIError("Please Enable Content Filtering !!")
		return false
	end
end

function blockGroupDisableCfgInputVal (configRow)
	if(db.getAttribute("ContentFiltering","rowid","1","Status") ~= "1") then
		printCLIError("Please Enable Content Filtering !!")
		return false
	end
	local GroupErrorMessage = " Already Disabled !!! \nInput(s) Discarded. Please enter fresh selection !! "
	if ( InitGroup1 == "0" and configRow["BlockSites.group1"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","1","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup2 == "0" and configRow["BlockSites.group2"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","2","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup3 == "0" and configRow["BlockSites.group3"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","3","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup4 == "0" and configRow["BlockSites.group4"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","4","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup5 == "0" and configRow["BlockSites.group5"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","5","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup6 == "0" and configRow["BlockSites.group6"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","6","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup7 == "0" and configRow["BlockSites.group7"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","7","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
	if ( InitGroup8 == "0" and configRow["BlockSites.group8"] == "1") then 
		printCLIError(db.getAttribute("LanGroup","rowid","8","GroupName") .. GroupErrorMessage)
		DeleteStaleInput()
		return false
	end
end

function blockGroupDisableCfgSave(configRow)
    RowId = configRow["BlockSites._ROWID_"]
    DBTable = "BlockSites"
    if (configRow["BlockSites.allGroups"] == "1") then 
            if ( InitGroup1 == "1") then configRow["BlockSites.group1"] = "1" end
            if ( InitGroup2 == "1") then configRow["BlockSites.group2"] = "1" end
            if ( InitGroup3 == "1") then configRow["BlockSites.group3"] = "1" end
            if ( InitGroup4 == "1") then configRow["BlockSites.group4"] = "1" end
            if ( InitGroup5 == "1") then configRow["BlockSites.group5"] = "1" end
            if ( InitGroup6 == "1") then configRow["BlockSites.group6"] = "1" end
            if ( InitGroup7 == "1") then configRow["BlockSites.group7"] = "1" end
            if ( InitGroup8 == "1") then configRow["BlockSites.group8"] = "1" end
    end
     --if add
   if (RowId == "-1") then
       errorFlag, statusCode = fwView.disableBlockGroups(configRow, RowId, "add")
    --if edit
    else
     RowId=1
	errorFlag, statusCode = fwView.disableBlockGroups(configRow, 1, "edit")
    end
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, 
                                    LANGUAGE)
    return errorFlag, statusMessage
end


function blockGroupEnableCfgSave(configRow)
    RowId = configRow["BlockSites._ROWID_"]
    DBTable = "BlockSites"
    if (configRow["BlockSites.allGroups"] == "1") then 
	    configRow["BlockSites.group1"] = "1"
            configRow["BlockSites.group2"] = "1"
            configRow["BlockSites.group3"] = "1"
            configRow["BlockSites.group4"] = "1"
            configRow["BlockSites.group5"] = "1"
            configRow["BlockSites.group6"] = "1"
            configRow["BlockSites.group7"] = "1"
            configRow["BlockSites.group8"] = "1"   
    end

 --if add
   if (RowId == "-1") then
       errorFlag, statusCode = fwView.enableBlockGroups(configRow, RowId, "add")
    --if edit
    else
     RowId=1
	errorFlag, statusCode = fwView.enableBlockGroups(configRow, 1, "edit")
    end
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, 
                                    LANGUAGE)
    return errorFlag, statusMessage
end

function blockGroupSetupGet(args)
    DBTable = "BlockSites"
    local resultTab = {}
    printLabel("Blocked Groups")
    print("List of Blocked Groups \n")
    local i = 0
    local table = db.getTable("BlockSites")
    local table1 = db.getTable("LanGroup")
 local testRow=db.getRow("LanGroup","_ROWID_","1")
--print(testRow["LanGroup.GroupName"])
--print(table1["LanGroup.GroupName"])
--    for k,v in pairs(table) do
        i = i + 1
        local row = fwView.groupConfigGet (table[i])
        local group = ""
        local group1 = ""
       --[[ if (row["BlockSites.allDays"] == "1") then
            group = "All Days"
        else	
        ]]--
        if (row["BlockSites.group1"] == "1") then
            group = group..testRow["LanGroup.GroupName"] .. ", "
	else
	    group1 = group1..testRow["LanGroup.GroupName"] .. ", "
        end
        if (row["BlockSites.group2"] == "1") then
	testRow=db.getRow("LanGroup","_ROWID_","2")
            group = group..testRow["LanGroup.GroupName"] .. ", "
           -- group = group.."group2" .. ", "
        else
	testRow=db.getRow("LanGroup","_ROWID_","2")
        group1 = group1..testRow["LanGroup.GroupName"] .. ", "
	-- group1 = group1.."group2" .. ", "
	end
	if (row["BlockSites.group3"] == "1") then
           	testRow=db.getRow("LanGroup","_ROWID_","3")
            group = group..testRow["LanGroup.GroupName"] .. ", "
	-- group = group.."group3" .. ", "
       else
	testRow=db.getRow("LanGroup","_ROWID_","3")
        group1 = group1..testRow["LanGroup.GroupName"] .. ", "

	-- group1 = group1.."group3" .. ", "
	 end
        if (row["BlockSites.group4"] == "1") then
        	testRow=db.getRow("LanGroup","_ROWID_","4")
            group = group..testRow["LanGroup.GroupName"] .. ", "
--    group = group.."group4" .. ", "
 	else
	testRow=db.getRow("LanGroup","_ROWID_","4")
        group1 = group1..testRow["LanGroup.GroupName"] .. ", "
	-- group1 = group1.."group4" .. ", "
        end
        if (row["BlockSites.group5"] == "1") then
          	testRow=db.getRow("LanGroup","_ROWID_","5")
            group = group..testRow["LanGroup.GroupName"] .. ", "
	 -- group = group.."group5" .. ", "
	else
		testRow=db.getRow("LanGroup","_ROWID_","5")
            group1 = group1..testRow["LanGroup.GroupName"] .. ", "
-- group1 = group1.."group5" .. ", "
        end
        if (row["BlockSites.group6"] == "1") then
           	testRow=db.getRow("LanGroup","_ROWID_","6")
            group = group..testRow["LanGroup.GroupName"] .. ", "
-- group = group.."group6" .. ", "
	else
 	testRow=db.getRow("LanGroup","_ROWID_","6")
            group1 = group1..testRow["LanGroup.GroupName"] .. ", "
--	group1 = group1.."group6" .. ", "
        end
        if (row["BlockSites.group7"] == "1") then
        	testRow=db.getRow("LanGroup","_ROWID_","7")
            group = group..testRow["LanGroup.GroupName"] .. ", "
--    group = group.."group7" .. ", "
	else
	testRow=db.getRow("LanGroup","_ROWID_","7")
            group1 = group1..testRow["LanGroup.GroupName"] .. ", "
--	 group1 = group1.."group7" .. ", "
        end
	if (row["BlockSites.group8"] == "1") then
       	testRow=db.getRow("LanGroup","_ROWID_","8")
            group = group..testRow["LanGroup.GroupName"] .. ", "
--     group = group.."group8" .. ", " 
	else
		testRow=db.getRow("LanGroup","_ROWID_","8")
            group1 = group1..testRow["LanGroup.GroupName"] .. ", "
--group1 = group1.."group8" .. ", "
        end
        group = group:sub(1, group:len()-2) --shave last comma
        group1 = group1:sub(1, group1:len()-2) --shave last comma
--    resTab.insertField (resultTab, "ROW ID", row["BlockSites._ROWID_"])
   -- resTab.insertField (resultTab, "Name", row["BlockSites.ScheduleName"])
    resTab.insertField (resultTab, "Blocked Groups", group)
    resTab.insertField (resultTab, "Unblocked Groups ", group1)
  --    end -- for
    resTab.print (resultTab, 0)
end


