/* portForwarding.js - API library for Portforwarding configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,11OCT10,mvb  written. 
*/

function appIPValidate ()
    {
	if (ipv4AddrOctetsValidate ('tblIPAddr', 'IP', false, true,
             'Invalid Local Server IP Address.', 'for octet', true) == false)
		return false;
	obj = document.getElementById('txtPort');
	if (numericValueRangeCheck (obj , 1, 
                            'Invalid End Port - Please enter a value between 1 - 65535.',
                            1, 65535, true, 'Invalid End Port number', "") == false)
         	return false;
    var maxLimitObj = document.getElementById ('hdMaxLimitRuleVal');
    var maxLimitVal = parseInt (maxLimitObj.value, 10);
    if (maxCountCheck ('hdCount', maxLimitVal, 'tblErrMsg') == false)
        return false;
	return true;	
    }
    
function serverIPValidate ()
    {
	if (ipv4AddrOctetsValidate ('tblSvrIPAddr', 'IP', false, true,
             'Invalid Local Server IP Address.', 'for octet', true) == false)
		return false;
    	var txtFieldIdArr = new Array ();    
	    txtFieldIdArr[0] = "txtFQDN,Please enter a valid Fully Qualified Domain Name.";
	    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        	 return false;
        if(!validateFQDN("txtFQDN"))
        {
        return false;
        }
		var fqdnObj = document.getElementById ('txtFQDN'); 
                if (fqdnObj && fqdnObj.value.length > 110) 
                       { 
                       alert ('FQDN maximum length must not exceed 110 characters.') 
                       return false; 
                       }
    var maxLimitObj = document.getElementById ('hdMaxLimitHostVal');
    var maxLimitVal = parseInt (maxLimitObj.value, 10);
    if (maxCountCheck ('hdHostCount', maxLimitVal, 'tblErrMsg') == false)
        return false;
	return true;	
    }
