/* radiusClient.js - API library for Radius Client configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12OCT10,mvb  written. 
*/



/* radius_client.htm */

function radiusClientInfoValidate ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter the shared secret phrase for the primary RADIUS server';
    var errMsgL10n2 = 'Please enter the shared secret phrase for the backup RADIUS server';
    var errMsgL10n3 = 'Please enter the NAS Identifier for the primary RADIUS server';
    var errMsgL10n4 = 'Please enter the NAS Identifier for the backup RADIUS server';    
    var errMsgL10n5 = 'Invalid  timeout value: Please enter a value between 1 and 99 seconds';
    var errMsgL10n6 = 'Invalid  timeout value:'
    var errMsgL10n7 = 'seconds.';
    var errMsgL10n8 = 'Invalid  maximum retry count.Please enter valid maximum retry count.';
    var errMsgL10n9 = 'Invalid  maximum retry count.'
    var errMsgL10n10 = 'Invalid primary RADIUS server IP address.';
     var errMsgL10n11 = 'for octet'
    var errMsgL10n12 = 'Invalid backup RADIUS server IP address.';      
    /* L10N Error Message Collection End */
        
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtPrimServSecretPhrase,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtBackupServSecretPhrase,"+ errMsgL10n2;
    txtFieldIdArr[2] = "txtPrimServNASIdentifier,"+ errMsgL10n3;
    txtFieldIdArr[3] = "txtBackupServNASIdentifier,"+ errMsgL10n4;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    var myObj = document.getElementById('txtTimeOutPeriod');
	if (numericValueRangeCheck (myObj, 1, 
                            errMsgL10n5,
                            1, 99, true, errMsgL10n6+':',
                            errMsgL10n7) == false)
        {
        myObj.focus ();
        return false;
        }
    myObj = document.getElementById('txtMaxRetryCount');
	if (numericValueRangeCheck (myObj, 1, 
                           errMsgL10n8,
                            0, 99, true,errMsgL10n9+':', "") == false)
        return false;
	if (ipv4AddrOctetsValidate ('tblPrimServIPAddr', 'IP', false, true,
             errMsgL10n10, errMsgL10n11+" ", true) == false)
    	return false;
	if (ipv4AddrOctetsValidate ('tblBackupServIpAddr', 'IP', false, true,
             errMsgL10n12, errMsgL10n11+" ", true) == false)
    	return false;         
    }


function radiusClientInit ()
	{
	radiusPrimaryServCheck ();
	radiusBackupServCheck ();
	}


var primaryServEnabled = false;
var backupServEnabled = false;

function radiusPrimaryServCheck ()
	{	
	var selValue = radioCheckedValueGet ('radiusClient.isEnable');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			primaryServEnabled = false;
			fieldStateChangeWr ('','tblPrimRadiusInfo','','');
			break;
		case 1:	/* YES */
			primaryServEnabled = true;
			fieldStateChangeWr ('','','','tblPrimRadiusInfo');
			break;
		}
	}
function radiusBackupServCheck ()
	{	
	var selValue = radioCheckedValueGet ('radiusClient.isEnable_1');
	if (!selValue) return false;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			backupServEnabled = false;
			fieldStateChangeWr ('','tblBackupRadiusInfo','','');
			break;
		case 1:	/* YES */
			backupServEnabled = true;
			fieldStateChangeWr ('','','','tblBackupRadiusInfo');
			break;
		}
	return true;
	}
