/* snmp.js - API library for SNMP configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12OCT10,mvb  written. 
*/

function snmpValidate ()
     {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid port number - Please enter a value between 0-65535';
    var errMsgL10n2 = 'Invalid port number';
    var errMsgL10n3 = 'Please enter a valid SNMP community string';
    var errMsgObjL10n = document.getElementById ('hd.invalPortBetSn');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalPortSn');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.snmpComstr');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value; 
     /* L10N Error Message Collection End */
    
     
	if (ipv4AddrOctetsValidate ('tblSnmpIpAddr', 'IP', false, true,
             document.getElementById('hd.invalIpAddr').value, document.getElementById('hd.foroctet').value+' ', true) == false)
	    return false;
        
	if (ipv4AddrOctetsValidate ('tblSnmpSubnetMask', 'SNM', false, true,
            document.getElementById('hd.invalSMAddr').value, document.getElementById('hd.foroctet').value+' ', true) == false)
	    return false;

	/* get and validate port */
	obj = document.getElementById('txtSnmpPort');
	if (portValueRangeCheck (obj, 0, 65535, 1024, 162, true, 'Invalid port number:') == false)
         return false; 
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtSnmpPort,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtSnmpCommunity,"+ errMsgL10n3;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    if(isProblemCharArrayCheck(txtFieldIdArr) == false)
         return false;

    if(maxCountCheck ('hdCount', 16, 'tblErrMsg') == false)
		return false;     
     return true;
     }


function snmpSysConfigValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter valid system contact value';
    var errMsgL10n2 = 'Please enter valid system location';
    var errMsgL10n3 = 'Please enter valid system name';
    var errMsgObjL10n = document.getElementById ('hd.valSysCont');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.valSysLoc');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.valSysName');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value; 
     /* L10N Error Message Collection End */    
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtSnmpSysContact,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtSnmpSysLocation,"+ errMsgL10n2;
    txtFieldIdArr[2] = "txtSnmpSysName," + errMsgL10n3;
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    if(isProblemCharArrayCheck (txtFieldIdArr) == false)
        return false;
        
    return true;
    }
    
 /* snmpV3UserValidate()
    This function validates SNMPv3 User. Returns false if validation fails else return true
 */
 function snmpV3UserValidate ()
     {
     /* L10N Error Message Collection Start */
     var valAuthPass = 'Please enter Valid Authentication Password';
     var valPrivPass = 'Please enter Valid Privacy Password';
     errMsgObjL10n = document.getElementById ('hd.entrValAuthPassSu');
     if (errMsgObjL10n) valAuthPass = errMsgObjL10n.value;
     errMsgObjL10n = document.getElementById ('hd.entrValPrivPassSu');
     if (errMsgObjL10n) valPrivPass = errMsgObjL10n.value;
     /* L10N Error Message Collection End */
    
     var txtFieldIdArr = new Array ();
     txtFieldIdArr[0] = "txtAuthPwd,"+ valAuthPass;
     txtFieldIdArr[1] = "txtPrivPwd,"+ valPrivPass;
     if (txtFieldArrayCheck (txtFieldIdArr) == false)
	    return false;

     if(intgAlgoKeyLenValidate()==false)
         return false;

     return true;
     }
     
/* securityTypeCheck ()
   This algorthm used for Enabling Dsiabling Security Authentication, Previliges 
   for SNMPV3 Users
*/
function securityTypeCheck ()
    {
    var selectedValue = comboSelectedValueGet  ('selSecurityType');
    if (!selectedValue) return;
    
    switch (parseInt (selectedValue, 10))
        {
        case 0:
        fieldStateChangeWr ('selAuthAlgo selPrivAlgo txtAuthPwd txtPrivPwd',' ','','');
            break;
        case 1:
            fieldStateChangeWr ('selPrivAlgo txtPrivPwd','','selAuthAlgo txtAuthPwd','');
            break;
        case 2:
            fieldStateChangeWr ('','','selAuthAlgo selPrivAlgo txtAuthPwd txtPrivPwd',' ');
            break;
        default:
            fieldStateChangeWr ('selAuthAlgo selPrivAlgo txtAuthPwd txtPrivPwd','','','');
        }
    }

function intgAlgoKeyLenValidate(){
    var _2c=comboSelectedValueGet("selAuthAlgo");
    if(_2c==null){
        return true;
    }
    var _2d=0;
    var _2e="";
    switch(_2c){
        case "MD5":
        _2d=16;
        _2e="for authentication password: For MD5 Key must be 16 characters long.";
        break;
        case "SHA":
        _2d=20;
        _2e="for authentication password: For SHA1 Key must be 20 characters long.";
        break;
        default:
        _2d=0;
        _2e="";
        break;
    }
    if(fieldLengthCheck("txtAuthPwd",_2d,_2d,"Invalid Key-In length "+_2e)==false){
    return false;
    }
    
    var _25=comboSelectedValueGet("selPrivAlgo");
    if(_25==null){
    return true;
    }
    var _26=0;
    var _27="";
    switch(_25){
        case "DES":
        _26=8;
        _27="for privacy passowrd: For DES Key must be 8 characters long.";
        break;
        case "AES":
        _26=16;
        _27="for privacy passowrd: For AES Key must be 16 characters long.";
        break;
        default:
        _26=0;
        _27="";
        break;
    }
    if(fieldLengthCheck("txtPrivPwd",_26,_26,"Invalid Key-In length "+_27)==false){
    return false;
    }
    return true;
};
