/* timeZone.js - API library for Time Zone configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,13OCT10,mvb  written. 
*/

var noDSTCountries = [
"Eniwetok",
"Midway Island",
"Hawaii",
"Marquesas Is.",
"Pitcairn Is.",
"Caracas",
"Mid-Atlantic",
"Baghdad",
"Abu Dhabi",
"Kabul",
"Bombay",
"Almaty",
"Burma",
"Bangkok",
"Beijing",
"Osaka",
"Brisbane",
"Norfolk Island (Kingston)",
"Tonga",
"Kiribati"
];


var domainNameExt = new Array(
'.com','.net','.aero','.asia','.cat','.jobs','.org','.biz','.coop','.info','.museum','.name',
'.pro','.tel','.travel','.edu','.gov','.int','.mil','.mobi','.ac','.ad','.ae','.af','.ag',
'.ai','.al','.am','.an','.ao','.aq','.ar','.as','.at','.au','.aw','.ax',
'.az','.ba','.bb','.bd','.be','.bf','.bg','.bh','.bi','.bj','.bm',
'.bn','.bo','.br','.bs','.bt','.bv','.bw','.by','.bz','.ca','.cc',
'.cd','.cf','.cg','.ch','.ci','.ck','.cl','.cm','.cn','.co','.cr','.cs',
'.cu','.cv','.cx','.cy','.cz','.de','.dj','.dk','.dm','.do','.dz',
'.ec','.ee','.eg','.er','.es','.et','.eu','.fi','.fj','.fk','.fm',
'.fo','.fr','.ga','.gb','.gd','.ge','.gf','.gg','.gh','.gi','.gl','.gm',
'.gn','.gp','.gq','.gr','.gs','.gt','.gu','.gw','.gy','.hk','.hm',
'.hn','.hr','.ht','.hu','.id','.ie','.il','.im','.in','.io','.iq',
'.ir','.is','.it','.je','.jm','.jo','.jp','.ke','.kg','.kh','.ki',
'.km','.kn','.kp','.kr','.kw','.ky','.kz','.la','.lb','.lc','.li',
'.lk','.lr','.ls','.lt','.lu','.lv','.ly','.ma','.mc','.md','.me','.mg',
'.mh','.mk','.ml','.mm','.mn','.mo','.mp','.mq','.mr','.ms','.mt',
'.mu','.mv','.mw','.mx','.my','.mz','.na','.nc','.ne','.nf','.ng',
'.ni','.nl','.no','.np','.nr','.nu','.nz','.om','.oz','.pa','.pe','.pf',
'.pg','.ph','.pk','.pl','.pm','.pn','.pr','.ps','.pt','.pw','.py',
'.qa','.re','.ro','.rw','.ru','.sa','.sb','.sc','.sd','.se','.sg',
'.sh','.si','.sj','.sk','.sl','.sm','.sn','.so','.sr','.st','.sv',
'.sy','.sz','.tc','.td','.tf','.tg','.th','.tj','.tk','.tm','.tn',
'.to','.tp','.tr','.tt','.tv','.tw','.tz','.ua','.ug','.uk','.um',
'.us','.uy','.uz','.va','.vc','.ve','.vg','.vi','.vn','.vu','.ws',
'.wf','.ye','.yt','.yu','.za','.zm','.zw','.COM','.NET','.AERO','.ASIA','.CAT','.JOBS','.ORG','.BIZ','.COOP','.INFO','.MUSEUM','.NAME',
'.PRO','.TEL','.TRAVEL','.EDU','.GOV','.INT','.MIL','.MOBI','.AC','.AD','.AE','.AF','.AG',
'.AI','.AL','.AM','.AN','.AO','.AQ','.AR','.AS','.AT','.AU','.AW','.AX',
'.AZ','.BA','.BB','.BD','.BE','.BF','.BG','.BH','.BI','.BJ','.BM',
'.BN','.BO','.BR','.BS','.BT','.BV','.BW','.BY','.BZ','.CA','.CC',
'.CD','.CF','.CG','.CH','.CI','.CK','.CL','.CM','.CN','.CO','.CR','.CS',
'.CU','.CV','.CX','.CY','.CZ','.DE','.DJ','.DK','.DM','.DO','.DZ',
'.EC','.EE','.EG','.ER','.ES','.ET','.EU','.FI','.FJ','.FK','.FM',
'.FO','.FR','.GA','.GB','.GD','.GE','.GF','.GG','.GH','.GI','.GL','.GM',
'.GN','.GP','.GQ','.GR','.GS','.GT','.GU','.GW','.GY','.HK','.HM',
'.HN','.HR','.HT','.HU','.ID','.IE','.IL','.IM','.IN','.IO','.IQ',
'.IR','.IS','.IT','.JE','.JM','.JO','.JP','.KE','.KG','.KH','.KI',
'.KM','.KN','.KP','.KR','.KW','.KY','.KZ','.LA','.LB','.LC','.LI',
'.LK','.LR','.LS','.LT','.LU','.LV','.LY','.MA','.MC','.MD','.ME','.MG',
'.MH','.MK','.ML','.MM','.MN','.MO','.MP','.MQ','.MR','.MS','.MT',
'.MU','.MV','.MW','.MX','.MY','.MZ','.NA','.NC','.NE','.NF','.NG',
'.NI','.NL','.NO','.NP','.NR','.NU','.NZ','.OM','.OZ','.PA','.PE','.PF',
'.PG','.PH','.PK','.PL','.PM','.PN','.PR','.PS','.PT','.PW','.PY',
'.QA','.RE','.RO','.RW','.RU','.SA','.SB','.SC','.SD','.SE','.SG',
'.SH','.SI','.SJ','.SK','.SL','.SM','.SN','.SO','.SR','.ST','.SV',
'.SY','.SZ','.TC','.TD','.TF','.TG','.TH','.TJ','.TK','.TM','.TN',
'.TO','.TP','.TR','.TT','.TV','.TW','.TZ','.UA','.UG','.UK','.UM',
'.US','.UY','.UZ','.VA','.VC','.VE','.VG','.VI','.VN','.VU','.WS',
'.WF','.YE','.YT','.YU','.ZA','.ZM','.ZW');


function timeZoneValidate ()
    {
     /* L10N Error Message Collection Start */
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a valid Select Stratum';
    var errMsgL10n2 = 'Please enter a valid time-server name or IP address for server1';
    var errMsgL10n11 = 'Please enter a valid time-server name or IP address for server2';
    var errMsgL10n3 = 'Invalid time - Enter valid hour between 1 and 12';
    var errMsgL10n4 = 'Invalid time.';
    var errMsgL10n5 = 'Invalid time. Enter valid minutes between 0 and 59';
    var errMsgL10n6 = 'Invalid time. Enter valid seconds between 0 and 59';
    var errMsgL10n7 = 'Invalid date. Enter valid day between 1 and 31';
    var errMsgL10n8 = 'Invalid month. Enter valid month between 1 and 12';
    var errMsgL10n9 = 'Invalid year. Enter valid year between 2000 and 2020';
    var errMsgL10n10 = 'Invalid date.';
    var errMsgObjL10n = document.getElementById ('hd.valTmservName1');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmBetHr');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmFr');
    if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmBetMin');
    if (errMsgObjL10n) errMsgL10n5 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmBetSec');
    if (errMsgObjL10n) errMsgL10n6 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmBetDay');
    if (errMsgObjL10n) errMsgL10n7 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmBetMon');
    if (errMsgObjL10n) errMsgL10n8 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmBetYr');
    if (errMsgObjL10n) errMsgL10n9 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmFr');
    if (errMsgObjL10n) errMsgL10n10 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.valTmservName2');
    if (errMsgObjL10n) errMsgL10n11 = errMsgObjL10n.value;
     /* L10N Error Message Collection End */

    var txtFieldIdArr = new Array ();    
	txtFieldIdArr[0] = "txtSelectStratum,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtServer1Info,"+ errMsgL10n2;

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        return false;
        
    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
         return false;

    var txtSelectStratumObj = document.getElementById('txtSelectStratum');
    if (numericValueRangeCheck (txtSelectStratumObj, "", "", 1, 15, true, "Invalid Select Stratum.", "") == false)
        return false;
         
    if (ipaddrValidate ('txtServer1Info') == false)
    	return false;
    
    var timeObj = document.getElementById('txtSpecificTimeHr');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n3, 0, 23, true, errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificTimeMin');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n5, 0, 59, true,errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificTimeSec');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n6, 0, 59, true, errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificDateDay');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n7, 1, 31, true,errMsgL10n10, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificDateMon');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n8, 1, 12, true, errMsgL10n10, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificDateYr');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n9, 2000, 2020, true,errMsgL10n10, "") == false)
        return false;

    var txtFieldIdArray1 = new Array ();
    txtFieldIdArray1[0] = "txtServer2Info,"+ errMsgL10n11;
    
    if (isProblemCharArrayCheck (txtFieldIdArray1) == false)
         return false;
         
    var server2nameObj = document.getElementById('txtServer2Info');
    if(!(server2nameObj.disabled) && server2nameObj.value != "")
        {
        if (ipaddrValidate ('txtServer2Info') == false)
    	return false;
    	}    	  	           

    return true;
    }
    
function timeZoneValidate1 ()
    {
     /* L10N Error Message Collection Start */
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a valid Select Stratum';
    var errMsgL10n2 = 'Please enter a valid time-server name or IP address for server1';
    var errMsgL10n11 = 'Please enter a valid time-server name or IP address for server2';
    var errMsgL10n3 = 'Invalid time - Enter valid hour between 1 and 12';
    var errMsgL10n4 = 'Invalid time.';
    var errMsgL10n5 = 'Invalid time. Enter valid minutes between 0 and 59';
    var errMsgL10n6 = 'Invalid time. Enter valid seconds between 0 and 59';
    var errMsgL10n7 = 'Invalid date. Enter valid day between 1 and 31';
    var errMsgL10n8 = 'Invalid month. Enter valid month between 1 and 12';
    var errMsgL10n9 = 'Invalid year. Enter valid year between 2000 and 2020';
    var errMsgL10n10 = 'Invalid date.';
    var errMsgObjL10n = document.getElementById ('hd.valTmservName1');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmBetHr');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmFr');
    if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmBetMin');
    if (errMsgObjL10n) errMsgL10n5 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalTimeTmBetSec');
    if (errMsgObjL10n) errMsgL10n6 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmBetDay');
    if (errMsgObjL10n) errMsgL10n7 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmBetMon');
    if (errMsgObjL10n) errMsgL10n8 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmBetYr');
    if (errMsgObjL10n) errMsgL10n9 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDateTmFr');
    if (errMsgObjL10n) errMsgL10n10 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.valTmservName2');
    if (errMsgObjL10n) errMsgL10n11 = errMsgObjL10n.value;
     /* L10N Error Message Collection End */

    var txtFieldIdArr = new Array ();    
	txtFieldIdArr[0] = "txtSelectStratum,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtServer1Info,"+ errMsgL10n2;

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        return false;
        
    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
         return false;

    var txtSelectStratumObj = document.getElementById('txtSelectStratum');
    if (numericValueRangeCheck (txtSelectStratumObj, "", "", 1, 15, true, "Invalid Select Stratum.", "") == false)
        return false;
    
    if (ipaddrValidate_new ('txtServer1Info') == false)
    	return false;
    
    var timeObj = document.getElementById('txtSpecificTimeHr');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n3, 0, 23, true, errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificTimeMin');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n5, 0, 59, true,errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificTimeSec');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n6, 0, 59, true, errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificDateDay');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n7, 1, 31, true,errMsgL10n10, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificDateMon');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n8, 1, 12, true, errMsgL10n10, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificDateYr');
	if (numericValueRangeCheck (timeObj , 1, errMsgL10n9, 2000, 2020, true,errMsgL10n10, "") == false)
        return false;

    var txtFieldIdArray1 = new Array ();
    txtFieldIdArray1[0] = "txtServer2Info,"+ errMsgL10n11;
    
    if (isProblemCharArrayCheck (txtFieldIdArray1) == false)
         return false;
         
    var server2nameObj = document.getElementById('txtServer2Info');
    if(!(server2nameObj.disabled) && server2nameObj.value != "")
        {
        if (ipaddrValidate_new ('txtServer2Info') == false)
    	return false;
    	}    	  	           

    return true;
    }

function ntpSvrTypeCheck ()
	{
	var selValue = radioCheckedValueGet ('ntp.useDefServers');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 1:	/* Use Default NTP server */
			fieldStateChangeWr ('txtServer1Info txtServer2Info', '', '', '');
			break;
		case 0:	/* Use Custom NTP server */
			fieldStateChangeWr ('', '', 'txtServer1Info txtServer2Info', '');
			break;
		}
	}
	    
function timeZoneInit ()
	{
	ntpSvrTypeCheck ();
	NTPModeCheck();
	//timezoneCheck ();
	cheIPv6ResolvFun ();
	}

function timezoneCheck()
	{
	var selTimezone = document.getElementById('selTimezone');
	var timezone = selTimezone.options[selTimezone.selectedIndex].text;
	if(!timezone) return;
	var len = noDSTCountries.length;
	for(var i=0; i<len; ++i)
		{
		if(timezone.indexOf(noDSTCountries[i]) != -1)
			{
			fieldStateChangeWr('chkAutoDaylight','','','');
			return;
			}
		}
	fieldStateChangeWr('','','chkAutoDaylight','');
	}

function ipaddrValidate (ipAddr)
    {
    var lastOctateVal = 0;
    var ipAddrObj = document.getElementById(ipAddr);    
    if(!ipAddrObj || ipAddrObj.disabled) return true;    
    var ipAddrObjArr = (ipAddrObj.value).split(".");
    if(ipAddrObjArr.length == 1)
    	{
    	alert("Invalid IP Address/Domain name. Please enter a valid IP Address/Domain name.");     	
    	ipAddrObj.focus();
    	return false;
    	}
    if(ipAddrObjArr.length) lastOctateVal = ipAddrObjArr[ipAddrObjArr.length - 1];
    if(!isNaN (lastOctateVal))
    	{
    	if(ipv4AddrValidate (ipAddrObj, 'IP', false, true, 'Invalid IP address.', 'for octet ', true) == false)
    		{
    		ipAddrObj.focus();
    		return false;
    		}
    	}
    else
    	{
    	if(checkDomainExtension (lastOctateVal) == false) 
    		{
    		alert("Please enter a valid domain name extension.");
    		return false;
    		}
    	if(ipAddrObj.value.length > 253 || ipAddrObj.value.length < 1)
    		{
    		alert("The domain cannot be bigger than 253 or less than 1 characters");    		
    		return false;
    		}
    	
    	if(checkEachNodeLength (ipAddrObjArr) == false) return false;
    	
		if (checkHostName1 (ipAddr, true, 'Invalid IP Address/Domain name: ', false) == false) 
			return false; 
		return true;  
		}
    }
/*
function: checkEachNodeLength
parameters: Array of nodes in a domain name.
purpose : Checks is number of characters in a node of a domain exceeds 63 characters.
return : true or false;
*/
function checkEachNodeLength (nodeArray)
	{
	for(var i = 0; i <= nodeArray.length - 1; i++)
		{
		var node = nodeArray[i];
		if(node.length > 63)
			{
			alert("Each node in the domain can only be 63 characters long.")
			return false;
			}			
		}
	return true;
	}
/*
function: checkDomainExtension
parameters: last octate value of domain name.
purpose : checks if the extension falls in the specified domains.
return : true or false;
*/

function checkDomainExtension (lastOctateVal)
	{
	var ext = "." + lastOctateVal;
	for(var i = 0; i <= domainNameExt.length - 1; i++)
		{
		if(ext == domainNameExt[i])
			return true;								
		}
	return false;
	} 
	
function cheIPv6ResolvFun ()
    {
    var hdIPmodObj = document.getElementById('isDisable');
    if(hdIPmodObj)
        var hdIPmodObjVal = hdIPmodObj.value;
    if(hdIPmodObjVal != '' && parseInt(hdIPmodObjVal, 10) == 3)
        fieldStateChangeWr('','','chkIPv6Resolv','');
    else
        fieldStateChangeWr('chkIPv6Resolv','','','');
    }
	
function NTPModeCheck()
	{
	var selObj = document.getElementById ('selNTPMode');
	if (!selObj) return;
	var direction = parseInt (selObj.value, 10);
    if (direction == 0)
        {
        fieldStateChangeWr ('selVPNPolicy txtSpecificTimeHr txtSpecificTimeMin txtSpecificTimeSec txtSpecificDateDay txtSpecificDateMon txtSpecificDateYr', '', 'txtSelectStratum chkSetManTime', '');
        allowManSetTime();
        }
	else if (direction == 1)
		fieldStateChangeWr ('txtSelectStratum selVPNPolicy chkSetManTime txtSpecificTimeHr txtSpecificTimeMin txtSpecificTimeSec txtSpecificDateDay txtSpecificDateMon txtSpecificDateYr', '', '', '');
	else
        fieldStateChangeWr ('txtSelectStratum chkSetManTime txtSpecificTimeHr txtSpecificTimeMin txtSpecificTimeSec txtSpecificDateDay txtSpecificDateMon txtSpecificDateYr', '', 'selVPNPolicy', '');
    optionValueSelect ('selVPNPolicy', 'hdSelVpnPolicy');
    }
    
 function allowManSetTime()
    {
    depFieldCheck ('chkSetManTime', true, '', '', 'txtSpecificTimeHr txtSpecificTimeMin txtSpecificTimeSec txtSpecificDateDay txtSpecificDateMon txtSpecificDateYr', '');
	depFieldCheck ('chkSetManTime', false, 'txtSpecificTimeHr txtSpecificTimeMin txtSpecificTimeSec txtSpecificDateDay txtSpecificDateMon txtSpecificDateYr', '', '', '');
	}
	
function ipaddrValidate_new (ipAddr)
    {
    var flag = 0;
    var resolveIPv6Chk = document.getElementById('chkIPv6Resolv');
    var ipAddrObj = document.getElementById(ipAddr);
    if(!(resolveIPv6Chk.disabled) && resolveIPv6Chk.checked == true)
        {
        flag = 1;
        }
    else
        {
        flag = 0;
        }
    if(flag == 1)
        {
        if(ipv6FormatCheck(ipAddr) == true)
            {
            if(ipv6Validate (ipAddr, false, true, '') == false)
                return false;
            }
        else
            {
            if(checkServerName(ipAddr) == false)
                return false;
            }
        }
    else if(flag == 0)
        {
        var txtIPVal = document.getElementById(ipAddr).value;
        if(ipFormatCheck(txtIPVal) == true)
            {
            if (ipv4Validate(ipAddr, 'IP', false, true, 'Invalid IP address', 'for octet ', true) == false)
                return false;
            }
        else
            {
            if(checkServerName(ipAddr) == false)
                return false;
            }
        }
     return true;
    }
function checkServerName (ipAddr)
    {
    var ipAddrObj = document.getElementById(ipAddr);
    var ipAddrObjArr = (ipAddrObj.value).split(".");
    if(ipAddrObjArr.length) lastOctateVal = ipAddrObjArr[ipAddrObjArr.length - 1];
    if(checkDomainExtension (lastOctateVal) == false)
        {
        alert("Please enter a valid domain name extension.");
        return false;
        }
    if(ipAddrObj.value.length > 253 || ipAddrObj.value.length < 1)
        {
        alert("The domain cannot be bigger than 253 or less than 1 characters");
        return false;
        }
    if(checkEachNodeLength (ipAddrObjArr) == false) return false;

    if (checkHostName1 (ipAddr, true, 'Invalid IP Address/Domain name: ', false) == false)
        return false;
    return true;
    }
